--
-- PostgreSQL database dump
--

-- Started on 2008-12-24 12:05:58 CET

SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = "PUBLIC", pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 1553 (class 1259 OID 16436)
-- Dependencies: 5
-- Name: message; Type: TABLE; Schema: PUBLIC; Owner: tracuser; Tablespace: 
--

CREATE TABLE message (
    id integer NOT NULL,
    forum integer,
    topic integer,
    replyto integer,
    "time" integer,
    author text,
    body text
);


ALTER TABLE "PUBLIC".message OWNER TO tracuser;

--
-- TOC entry 1572 (class 1259 OID 16542)
-- Dependencies: 1553 5
-- Name: message_id_seq; Type: SEQUENCE; Schema: PUBLIC; Owner: tracuser
--

CREATE SEQUENCE message_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE "PUBLIC".message_id_seq OWNER TO tracuser;

--
-- TOC entry 1850 (class 0 OID 0)
-- Dependencies: 1572
-- Name: message_id_seq; Type: SEQUENCE OWNED BY; Schema: PUBLIC; Owner: tracuser
--

ALTER SEQUENCE message_id_seq OWNED BY message.id;


--
-- TOC entry 1851 (class 0 OID 0)
-- Dependencies: 1572
-- Name: message_id_seq; Type: SEQUENCE SET; Schema: PUBLIC; Owner: tracuser
--

SELECT pg_catalog.setval('message_id_seq', 1, false);


--
-- TOC entry 1844 (class 2604 OID 16554)
-- Dependencies: 1572 1553
-- Name: id; Type: DEFAULT; Schema: PUBLIC; Owner: tracuser
--

ALTER TABLE message ALTER COLUMN id SET DEFAULT nextval('message_id_seq'::regclass);


--
-- TOC entry 1847 (class 0 OID 16436)
-- Dependencies: 1553
-- Data for Name: message; Type: TABLE DATA; Schema: PUBLIC; Owner: tracuser
--

COPY message (id, forum, topic, replyto, "time", author, body) FROM stdin;
1	2	6	-1	1205573450	kasper	I'm very glad you like it :) To respond to what you say you're looking for (relative report paths) it would require some configuration on the birt-webapplication also, since it's BIRT_HOME would have to follow along to the relative path. I guess this is possible too, but would require basicly a BIRT installation per portlet instance, as I see it?\r\n\r\nTo be honest I haven't dug very deep into the birt API, so maybe there's a smart way to provide a feature like this.
2	1	3	-1	1205608446	kasper	Just tried postgresql out and these are my conclusions:\r\n\r\n * Connectivity works fine.\r\n * A lot of "tables" are added to the Schema which are not real tables, for example constraints, attibutes etc. This seems like postgresql metadata which we would want to filter out.\r\n * Reading "real" tables works perfectly.\r\n\r\nAdded this ticket for the issue: #95
3	1	7	-1	1205625169	kasper	Oracle is still one of the untested db-vendors (I actually know that some of the developers have managed to get a hole through, but it's not documented yet, we're [/trac/discussion/1/3 working on it right now] though!).\r\n\r\nAs far as I know Oracly is fully JDBC-compliant so the logical answer would be yes, it is possible to connect.\r\n\r\nYou need to add the driver jar-file to the drivers-folder and then use the startup.cmd (or .sh depending on your OS) for starting DataCleaner. Please let us know if it works out. If not I would be most interested in any problems you might have and try and fix them!
4	1	7	3	1205630878	chorn@post.com	I have tried dropping ojdbc14.jar into the drivers folder and used the cmd file to start up. I select 'sun.jdbc.odbc.JdbcOdbcDriver', configure my DSN, user, password, and schema pattern. (I am assuming this means the name of the schema I intend to point at) and get an error of 'Could not open connection! Error: java.sql.SQLException: [Oracle][ODBC]Driver not capable.'\r\n\r\nThanks for your assistance!
5	1	7	-1	1205664148	kasper	I wouldn't expect you to use the ODBC-driver that you're using. This is for accessing your database through Suns JDBC-to-ODBC bridge. Instead I would say that it's better if you use the Oracle driver:\r\n\r\noracle.jdbc.driver.OracleDriver\r\n\r\nReading from Oracles website, this is the template for a connection string:\r\n\r\njdbc:oracle:thin:@host:port:sid\r\n\r\nI'm downloading Oracle Express edition now so I can test this myself, but that may take while :)
6	1	7	5	1205674949	chorn@post.com	That did the trick! Problem solved. I will let you know how it goes after I have time to poke around a bit...\r\n\r\nThanks again!
7	1	7	6	1205675065	chorn@post.com	One thought: \r\n\r\nWhen I point the tool at a large schema, there is a very long pause, presumably as the tool tries to touch the schema and return the initial list of tables. Is there a way to set a table pattern to restrict the number of tables it hits? 
8	1	7	7	1205677784	kasper	There actually is that option at the API (core) level, but we haven't made any user interface for it yet, but I'll add it to our ticket system so look for it in future versions :)
9	1	3	-1	1205683561	kasper	Just added fixes to support:\r\n\r\n * Oracle (10g express edition tested and verified)\r\n * Postgresql
10	1	8	-1	1206273457	beno	By the way, I really like the product other than this "missing feature" :)
11	1	8	-1	1206357203	kasper	This feature has not been included in the roadmap, but I see no reason why not! And you're right, it seems like a very relevant thing. So I will add a ticket for it right away.
12	1	8	11	1206396190	beno	Very good. Looking foward to trying it out.
13	1	3	-1	1206794883	kasper	Added this wiki page for info on database compliancy:\r\nhttp://www.eobjects.dk/trac/wiki/DataCleanerFeatures\r\n\r\nPlease, if you test a database you're very welcome to add the corresponding info on that page!
14	1	9	-1	1208205471	beno	Downloading the package now. Looking forward to checking it out.
15	1	11	-1	1208381380	kasper	No problem :)\r\n\r\nDid you check out the BuildingDataCleaner page? If you want to build DataCleaner from within eclipse I encourage you to get the m2eclipse plugin (eclipse update site: http://m2eclipse.sonatype.org/update/) then it will build itself when you check it out. To run DataCleaner from your own build you will have to run the maven "install" goals like this (ripoff from the BuildingDataCleaner page):\r\n\r\n{{{\r\n cd DataCleaner-core\r\n mvn clean install\r\n cd ../DataCleaner-gui\r\n mvn clean install\r\n}}}\r\n\r\nTo verify that everything went OK maven should end it's build by echoing "BUILD SUCCESSFUL" :)\r\n\r\nOh and a last note - I'm guessing you already know that you can download a pre-built version from sourceforge, right?
16	1	11	15	1208381453	kasper	Ah and I forgot to say that when you have built it you can use the included .cmd/.sh files to execute the program :)
17	1	15	-1	1210337134	kasper	Hi MFontana.\r\n\r\nIt's hard to say from just reading your description what goes wrong... Can you perhaps paste in some more details of the error? Perhaps the whole stack-trace? And furthermore, can you tell me if the error occurs in the console or in an error dialog?\r\n\r\n/Kasper
18	1	15	-1	1210795605	kasper	There will be some improvements to performance in the 1.1 release of DataCleaner, so stay tuned. In the meanwhile, if what you're experiencing OutOfMemoryError's (which is the only type of error I can think of that matches your description), try and increase the size of your heap space. This is done by opening your start-datacleaner.cmd/.sh file and changing the argument "-Xmx1024m" (equivalent to 1GB of heap space) to something bigger. If you have loads of memory available I'd recommend you beef it up to a couple of gigabytes if you want to do a really large profiling.
19	1	15	18	1211024116	MFontana	Thank you, I've tried increasing heap space and everything is working fine. 
20	1	15	19	1211031756	kasper	Great, I'm really glad to hear that! :)\r\n\r\nEven though this fixes your problem for now I've gone ahead and made an issue about this...\r\nEven though the JDBC spec. has specific ways of keeping memory consumption low (by streaming data and setting a fetch size for how many rows to keep in memory) I've experienced that some database vendors do not live up to this part of the specification. So we might try and solve the problem using other methods, for example by rewriting the queries to retrieve more than one resultset of smaller sizes instead of one big query.\r\n\r\nYou can follow the issue progress if you're interested, here: #134\r\n\r\nIf we come up with a good solution you can be certain that I'll also write a lot about it on [http://kaspersorensen.blogspot.com my blog] ;-)
21	1	17	-1	1211368741	kasper	You're absolutely right, we need a lot of improvement on the reporting side. \r\n\r\nThere is a ticket (#139) to enable easier copying to the clipboard. But in response to your request here are my thoughts on this (which can be changed over time, but it's all a question of time and resources right now):\r\n * My original plan with DataCleaner GUI was that it should be a "desktop app", meaning that it was intended for single users who had a somewhat "explorative" goal. I never thought of reporting in this use case scenario, but I will definately put some more work into it now that I know that it's a real feature request.\r\n * In addition we are planning the webmonitor webapplication which should be used for enterprises who want to schedule and monitor data quality over time. This would be an ideal place to put reporting using some intelligent report format (eclipse BIRT is my personal favourite, but let's see). The webmonitor is still in a very early stage so this doesn't really respond to your wishes.\r\n\r\nOut of curiosity, can I ask in what kind of environment you are using DataCleaner? I think you are one of the early adopters and I would love to hear about the users experiences.
22	1	17	21	1211374547	anonymous	I'm using data clenaner as a data profiling software for both academic and commercial projects based on SQL Server and MySQL. The main focus is on ETL processes (developed using kettle, ad hoc SQL procedures, Integration Services and Informatica Power Center) and data quality. I think DataCleaner could be a good tool to evaluate dataquality, at least to define the big picture. Databases involved in these projects have tables reaching 9-10 million rows, with an average of 1,5 million rows. We adopted Pentaho as BI platform. My request of reporting features is due to the need of documenting result step by step during the ETL process. Tell me if you nedd more info.\r\n\r\nJust one more idea: have you ever tought about collapsing datacleaner inside an ETL tool or even just a BI platform? It could be very appreciated and your tool may gain a large visibility. Pentaho could be a good proving ground ;-)
23	1	17	22	1211380359	kasper	Your scenario sounds very interesting. I'm glad to hear that you're using it to profile MS SQL because we actually haven't tested that database! :-O If you don't mind we would be very happy if you could go to our [DataCleanerFeatures features page] and fill in some info on how to connect to MS SQL (look at the bottom of the page, there are similar examples with MySQL etc.)?\r\n\r\nPersonally I don't particularly like Pentaho. Not from a user point of view, because their solutions seem to work pretty OK, but from a developer point of view I think they are doing a lot of things wrong. I have been in contact with them but they don't seem to have a lot of interest in DataCleaner either. We are right now talking to the guys from SpagoBI about some sort of collaboration with them, because they have an architecture that is much more in line with my ideas of good design and they are also more open to new ideas. So let's hope that we can get a good collaboration up and running with them.
24	1	17	23	1211382748	matteo.fontana@statistica.unimib.it	Added MSSQL compliance references.\r\n\r\nWell about Peantaho vs SpagoBI we've to look at the problem from an opposite point of view: we've to pay attention to the user point of view and I believe that Pentaho's solution much easier (both on understanding and implementing). But I also believe their ETL solution still has to grow (a lot ;-)) and I'm looking for an ETL open source project that can deal with large databases.\r\n\r\nI leave you my email address.\r\nLet's keep in touch.
25	1	17	24	1211395444	kasper	Thank you very much for the MSSQL docs.\r\n\r\nI know that Pentaho is easier to implement and actually I still feel that there's a lot of opportunities for improvement in both suites on the usability and integration side. I feel that a lot of the technologies are too fragmented and there's too little metadata to tie the ends together.\r\n\r\nAlso when investigating your previous request about large databases I was dissapointed to see that none of the ETL tools out there had come as far as we actually have (by version 1.1) in optimizing and splitting up queries for the sake of control over memory consumption. This is also why we've spent some time seperating some initial DataCleaner core code out to the MetaModel code - because we actually "invented" something that was not out there in the middleware market already. Check out ticket #134 for more info.\r\n\r\nYes let's keep in touch, you can find all my contact info at [KasperSorensen my wiki page]. I think it's great to hear what "real users" think of the product, it definately helps us prioritize the tickets because right now we wan't people to get interested and build the community.
26	1	17	24	1212655519	kasper	Hi MFontana\r\nJust to let you know, I just finished working on the improved "copy to clipboard" functionality yesterday. So now you can right click on any table in datacleaner and copy 1) the selected cells or 2) the entire table.\r\n\r\nYou will of course have to wait a bit for version 1.2 of DataCleaner or [BuildingDataCleaner build the app] yourself. Or you could do a quick and dirty update (assuming you use the 1.1 development release) and just replace these jar files into your '''target''' and '''target/lib''' dirs:\r\n\r\n * [/hudson/job/DataCleaner-gui/ws/trunk/target/datacleaner-gui.jar datacleaner-gui.jar] (to '''target''')\r\n * [/hudson/job/DataCleaner-core/ws/trunk/target/DataCleaner-core-1.2-SNAPSHOT.jar DataCleaner-core-1.2-SNAPSHOT.jar] (to '''target/lib''')\r\n * [/hudson/job/MetaModel/ws/trunk/target/MetaModel-0.3-SNAPSHOT.jar MetaModel-0.3-SNAPSHOT.jar] (to '''target/lib''')\r\n\r\nHope it works out.
27	1	20	-1	1213386969	kasper	Hi,\r\nIf your user is not allowed to access a schema, then the schema won't be visible in DataCleaner - we can't bypass you databases security ;-)\r\nBut what I think you mean is that your user has access to several schemas? In DataCleaner 1.0 this should be possible (to my knowledge, but please let me know if I'm wrong!) and in the current development version I think it's one of the known shortcomings?\r\n\r\nI'm not able to test it before tomorrow though - anyone else than me who has something to add to this?
28	1	20	-1	1213456694	kasper	OK I've looked into this and if you're using the development edition of DataCleaner then yes, we definately have a problem. I will fix it right away because this bug is actually a "conscious" one - it was based of my misunderstanding of how Oracle works, heh, sorry.
29	1	20	-1	1213458364	kasper	This has been fixed as of revision [446].\r\nIf you want this bug fixed and can't wait for version 1.2, here's what you need to do:\r\n * Download the [/hudson/job/DataCleaner-gui/ws/trunk/target/datacleaner-gui.jar gui jar] and put it in '''target'''.\r\n * Download the [/hudson/job/DataCleaner-core/ws/trunk/target/DataCleaner-core-1.2-SNAPSHOT.jar core jar] and put it in '''target/lib'''.\r\n * Download the [/hudson/job/MetaModel/ws/trunk/target/MetaModel-0.3-SNAPSHOT.jar metamodel jar] and put it in '''target/lib'''.
30	1	23	-1	1214430656	kasper	Hi,\r\n\r\nThanks for the report and I'm sorry to hear about your troubles. For 1.2 we've changed the underlying query-mechanism to use MetaModel and it's [MetaModelCompliancy compliancy with MS SQL] is still a gray area I'm afraid. We're planning to incorporate integrationtests of MS SQL which will guarantee compatibility, but we're not quite there yet (primarily we are in need of a  MS SQL server for executing the tests).\r\n\r\nIn previous versions of !DataCleaner MS SQL was reported to work fine, did you take a look at DataCleanerMicrosoftSql ?\r\n\r\nPlease post a defect ticket (component = MetaModel) and we will look into it shortly!
31	1	23	-1	1214431150	kasper	Wait a sec.\r\n\r\nCan you preview other tables in your database?\r\n\r\nBecause [http://www.derkeiler.com/Newsgroups/microsoft.public.sqlserver.security/2003-11/0153.html this discussion] which have some similarities to your description of the bug, this might be a security access restriction playing with us. Are you connecting as the same user from withing datacleaner as you are in your oracle client? Please take one more look and if you can't find the cause - please post the bug ;-) And if you find it we would appreciate to hear about it so we can post it for future requests!
32	1	23	31	1214434652	kgeis@berkeley.edu	Thanks.  Your response was enough to prod me into trying other things.  I changed from\r\n\r\n   URL: jdbc:sqlserver://host:port\r\n\r\n   Catalog: my_database\r\n\r\nto\r\n\r\n   URL: jdbc:sqlserver://host:port;database=my_database\r\n\r\n   Catalog: <blank>\r\n\r\nand it works now.
33	1	23	32	1214455534	kasper	Great, I'm very glad to hear so! That whole catalog thing is beginning to be somewhat a mystery to me. Seems almost no databases use that property, but we kept it in the dialog to ensure that if some databases use it we would have the option available.
34	1	22	-1	1214908303	asbjorn	A OS X bundle is now available on sourceforge as well... 
35	1	19	-1	1215407272	kasper	Additionally, now our repository has been set up for synchronization with the central repository: http://repo1.maven.org/maven2/dk/eobjects/
36	1	20	29	1215605775	anonymous	Sorry it took me a while to test it (with version 1.2 now). The initial problem has gone however now I'm not able to work with tables in the schemas at all. As expected I see a tree (in Profiler) of all Oracle schemas with expandable thoses that actually have objects accessible in them. But when I expand the tree those tables aren't recognized as tables.\r\n\r\nOh I just looked at traces and there is a lot of errors in there while reading database metadata. The first one looks like this:\r\n\r\nINFO  JdbcDataContextStrategy - Querying for table types {TABLE,VIEW} in catalog: null\r\nINFO  JdbcDataContextStrategy - Querying for table types {TABLE,VIEW} in catalog: null\r\nINFO  JdbcDataContextStrategy - Querying for table types {TABLE,VIEW} in catalog: null\r\nINFO  JdbcDataContextStrategy - Querying for table types {TABLE,VIEW} in catalog: null\r\nINFO  JdbcDataContextStrategy - Querying for table types {TABLE,VIEW} in catalog: null\r\nERROR JdbcDataContextStrategy - Error retriving table metadata\r\njava.sql.SQLException: ORA-01031: insufficient privileges\r\n\r\n\tat oracle.jdbc.driver.DatabaseError.throwSqlException(DatabaseError.java:112)\r\n\tat oracle.jdbc.driver.T4CTTIoer.processError(T4CTTIoer.java:331)\r\n\tat oracle.jdbc.driver.T4CTTIoer.processError(T4CTTIoer.java:288)\r\n\tat oracle.jdbc.driver.T4C8Oall.receive(T4C8Oall.java:745)\r\n\tat oracle.jdbc.driver.T4CStatement.doOall8(T4CStatement.java:207)\r\n\tat oracle.jdbc.driver.T4CStatement.executeForRows(T4CStatement.java:957)\r\n\tat oracle.jdbc.driver.OracleStatement.doExecuteWithTimeout(OracleStatement.java:1170)\r\n\tat oracle.jdbc.driver.OracleStatement.executeUpdateInternal(OracleStatement.java:1623)\r\n\tat oracle.jdbc.driver.OracleStatement.executeUpdate(OracleStatement.java:1588)\r\n\tat oracle.jdbc.OracleDatabaseMetaData.getIndexInfo(OracleDatabaseMetaData.java:3486)\r\n\tat dk.eobjects.metamodel.JdbcDataContextStrategy.populateTables(JdbcDataContextStrategy.java:245)\r\n\tat dk.eobjects.metamodel.JdbcDataContextStrategy.getSchemaByName(JdbcDataContextStrategy.java:667)\r\n\tat dk.eobjects.metamodel.DataContext.getSchemaByName(DataContext.java:260)\r\n\tat dk.eobjects.metamodel.DataContext.getSchemas(DataContext.java:201)\r\n\tat dk.eobjects.datacleaner.gui.widgets.SchemaTree.updateTree(SchemaTree.java:54)\r\n\tat dk.eobjects.datacleaner.gui.widgets.SchemaTree.update(SchemaTree.java:86)\r\n\tat java.util.Observable.notifyObservers(Unknown Source)\r\n\tat java.util.Observable.notifyObservers(Unknown Source)\r\n\tat dk.eobjects.datacleaner.gui.model.DataContextSelection.setDataContext(DataContextSelection.java:67)\r\n\tat dk.eobjects.datacleaner.gui.GuiHelper.selectSchemaByDatabase(GuiHelper.java:161)\r\n\tat dk.eobjects.datacleaner.gui.dialogs.OpenDatabaseDialog$2.actionPerformed(OpenDatabaseDialog.java:157)\r\n\tat javax.swing.AbstractButton.fireActionPerformed(Unknown Source)\r\n\tat javax.swing.AbstractButton$Handler.actionPerformed(Unknown Source)\r\n\tat javax.swing.DefaultButtonModel.fireActionPerformed(Unknown Source)\r\n\tat javax.swing.DefaultButtonModel.setPressed(Unknown Source)\r\n\tat javax.swing.plaf.basic.BasicButtonListener.mouseReleased(Unknown Source)\r\n\tat java.awt.Component.processMouseEvent(Unknown Source)\r\n\tat javax.swing.JComponent.processMouseEvent(Unknown Source)\r\n\tat java.awt.Component.processEvent(Unknown Source)\r\n\tat java.awt.Container.processEvent(Unknown Source)\r\n\tat java.awt.Component.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Container.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Component.dispatchEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.retargetMouseEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.processMouseEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.dispatchEvent(Unknown Source)\r\n\tat java.awt.Container.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Window.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Component.dispatchEvent(Unknown Source)\r\n\tat java.awt.EventQueue.dispatchEvent(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpOneEventForFilters(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEventsForFilter(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEventsForFilter(Unknown Source)\r\n\tat java.awt.Dialog$1.run(Unknown Source)\r\n\tat java.awt.Dialog$3.run(Unknown Source)\r\n\tat java.security.AccessController.doPrivileged(Native Method)\r\n\tat java.awt.Dialog.show(Unknown Source)\r\n\tat java.awt.Component.show(Unknown Source)\r\n\tat java.awt.Component.setVisible(Unknown Source)\r\n\tat java.awt.Window.setVisible(Unknown Source)\r\n\tat java.awt.Dialog.setVisible(Unknown Source)\r\n\tat dk.eobjects.datacleaner.gui.widgets.OpenDatabaseButton$1.actionPerformed(OpenDatabaseButton.java:40)\r\n\tat javax.swing.AbstractButton.fireActionPerformed(Unknown Source)\r\n\tat javax.swing.AbstractButton$Handler.actionPerformed(Unknown Source)\r\n\tat javax.swing.DefaultButtonModel.fireActionPerformed(Unknown Source)\r\n\tat javax.swing.DefaultButtonModel.setPressed(Unknown Source)\r\n\tat javax.swing.plaf.basic.BasicButtonListener.mouseReleased(Unknown Source)\r\n\tat java.awt.Component.processMouseEvent(Unknown Source)\r\n\tat javax.swing.JComponent.processMouseEvent(Unknown Source)\r\n\tat java.awt.Component.processEvent(Unknown Source)\r\n\tat java.awt.Container.processEvent(Unknown Source)\r\n\tat java.awt.Component.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Container.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Component.dispatchEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.retargetMouseEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.processMouseEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.dispatchEvent(Unknown Source)\r\n\tat java.awt.Container.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Window.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Component.dispatchEvent(Unknown Source)\r\n\tat java.awt.EventQueue.dispatchEvent(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpOneEventForFilters(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEventsForFilter(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEventsForHierarchy(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEvents(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEvents(Unknown Source)\r\n\tat java.awt.EventDispatchThread.run(Unknown Source)\r\n
37	1	20	36	1215605991	anonymous	Also I've noticed - FIRST table of every schema is loaded OK, but not the rest.
38	1	20	37	1215610013	kasper	What do you mean by\r\n{{{\r\nBut when I expand the tree those tables aren't recognized as tables.\r\n}}}\r\nand \r\n{{{\r\nFIRST table of every schema is loaded OK, but not the rest.\r\n}}}\r\n?\r\n\r\nIs it that only the first table of each schema is available in the tree?\r\n\r\nThe important part of the stacktrace is this:\r\n{{{\r\nError retriving table metadata java.sql.SQLException: ORA-01031: insufficient privileges\r\n}}}\r\nAnd it's caused by calling '''metaData.getIndexInfo(...)''' which you apparently don't have privileges to do. Can you grant your user privileges to read index info?\r\n\r\nEven though I'm not sure I understand the part about "only the first table works" I have an idea: The '''metaData.getIndexInfo(...)''' is called within an iteration that loops through all tables. If the method throws an exception then that iteration will stop and the other tables will not be processed. I will fix this for 1.3 (since the indexInfo can be omitted if not available) but the only thing you can do right now is to grant your user more privileges I think.
39	1	20	38	1215611126	anonymous	Yes, you have described that all correctly. The thing is - Oracle doesn't have any privileges for indexes specifically, so in fact its probably their JDBC driver problem (according to this its been like that for a long time: \r\nhttp://coding.derkeiler.com/Archive/Java/comp.lang.java.databases/2005-06/msg00026.html\r\n)\r\n\r\nSo skipping index introspection is very important for Oracle users I think.
40	1	20	39	1215611204	kasper	OK I've made the fix. Please download this jar-file and replace it with the other MetaModel jar in your '''datacleaner/target/lib''' directory:\r\n\r\nhttp://datacleaner.sourceforge.net/m2-repo/dk/eobjects/commons/MetaModel/1.0.1/MetaModel-1.0.1.jar\r\n\r\nDoes it work now? It should... :)
41	1	20	40	1215612076	anonymous	I have two: MetaModel-1.0.jar and MetaModel-0.3-SNAPSHOT.jar Which one should I replace?
42	1	20	41	1215612270	kasper	Heh, delete both and drop in the 1.0.1 version in there instead.
43	1	20	42	1215612467	anonymous	Yes, it works! Thank you very much!
44	1	20	43	1215612832	kasper	You're welcome! Please let us know how it works out for you in the future. Maybe you can contribute with a "user story"? We're looking for people and organizations who can testament their use of DataCleaner...
45	1	20	44	1215613750	anonymous	Not quite solved though - the logs still see a lot of errors before I start to get this:\r\n\r\nWARN  JdbcDataContextStrategy - Could not retrieve index info for table: ALL$OLAP2UHIERDIM_KEYCOL_MAP\r\nINFO  JdbcDataContextStrategy - ORA-01702: a view is not appropriate here\r\n\r\nWARN  JdbcDataContextStrategy - Could not retrieve index info for table: ALL$OLAP2UHIER_CUSTOM_SORT\r\nINFO  JdbcDataContextStrategy - ORA-01702: a view is not appropriate here\r\n\r\n Could not retrieve index info for table: ALL$OLAP2UJOIN_KEY_COLUMN_USES\r\nINFO  JdbcDataContextStrategy - ORA-00604: error occurred at recursive SQL level 1\r\nORA-01000: maximum open cursors exceeded\r\n\r\nERROR JdbcDataContextStrategy - Error retriving table metadata\r\njava.sql.SQLException: ORA-01000: maximum open cursors exceeded\r\n\r\n\tat oracle.jdbc.driver.DatabaseError.throwSqlException(DatabaseError.java:112)\r\n\tat oracle.jdbc.driver.T4CTTIoer.processError(T4CTTIoer.java:331)\r\n\tat oracle.jdbc.driver.T4CTTIoer.processError(T4CTTIoer.java:288)\r\n\tat oracle.jdbc.driver.T4C8Oall.receive(T4C8Oall.java:745)\r\n\tat oracle.jdbc.driver.T4CPreparedStatement.doOall8(T4CPreparedStatement.java:216)\r\n\tat oracle.jdbc.driver.T4CPreparedStatement.executeForDescribe(T4CPreparedStatement.java:810)\r\n\tat oracle.jdbc.driver.OracleStatement.executeMaybeDescribe(OracleStatement.java:1039)\r\n\tat oracle.jdbc.driver.T4CPreparedStatement.executeMaybeDescribe(T4CPreparedStatement.java:850)\r\n\tat oracle.jdbc.driver.OracleStatement.doExecuteWithTimeout(OracleStatement.java:1134)\r\n\tat oracle.jdbc.driver.OraclePreparedStatement.executeInternal(OraclePreparedStatement.java:3339)\r\n\tat oracle.jdbc.driver.OraclePreparedStatement.executeQuery(OraclePreparedStatement.java:3384)\r\n\tat oracle.jdbc.driver.OracleDatabaseMetaData.getColumns(OracleDatabaseMetaData.java:262)\r\n\tat dk.eobjects.metamodel.JdbcDataContextStrategy.populateTables(JdbcDataContextStrategy.java:202)\r\n\tat dk.eobjects.metamodel.JdbcDataContextStrategy.getSchemaByName(JdbcDataContextStrategy.java:680)\r\n\tat dk.eobjects.metamodel.DataContext.getSchemaByName(DataContext.java:260)\r\n\tat dk.eobjects.metamodel.DataContext.getSchemas(DataContext.java:201)\r\n\tat dk.eobjects.datacleaner.gui.widgets.SchemaTree.updateTree(SchemaTree.java:54)\r\n\tat dk.eobjects.datacleaner.gui.widgets.SchemaTree.update(SchemaTree.java:86)\r\n\tat java.util.Observable.notifyObservers(Unknown Source)\r\n\tat java.util.Observable.notifyObservers(Unknown Source)\r\n\tat dk.eobjects.datacleaner.gui.model.DataContextSelection.setDataContext(DataContextSelection.java:67)\r\n\tat dk.eobjects.datacleaner.gui.GuiHelper.selectSchemaByDatabase(GuiHelper.java:161)\r\n\tat dk.eobjects.datacleaner.gui.dialogs.OpenDatabaseDialog$2.actionPerformed(OpenDatabaseDialog.java:157)\r\n\tat javax.swing.AbstractButton.fireActionPerformed(Unknown Source)\r\n\tat javax.swing.AbstractButton$Handler.actionPerformed(Unknown Source)\r\n\tat javax.swing.DefaultButtonModel.fireActionPerformed(Unknown Source)\r\n\tat javax.swing.DefaultButtonModel.setPressed(Unknown Source)\r\n\tat javax.swing.plaf.basic.BasicButtonListener.mouseReleased(Unknown Source)\r\n\tat java.awt.Component.processMouseEvent(Unknown Source)\r\n\tat javax.swing.JComponent.processMouseEvent(Unknown Source)\r\n\tat java.awt.Component.processEvent(Unknown Source)\r\n\tat java.awt.Container.processEvent(Unknown Source)\r\n\tat java.awt.Component.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Container.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Component.dispatchEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.retargetMouseEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.processMouseEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.dispatchEvent(Unknown Source)\r\n\tat java.awt.Container.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Window.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Component.dispatchEvent(Unknown Source)\r\n\tat java.awt.EventQueue.dispatchEvent(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpOneEventForFilters(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEventsForFilter(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEventsForFilter(Unknown Source)\r\n\tat java.awt.Dialog$1.run(Unknown Source)\r\n\tat java.awt.Dialog$3.run(Unknown Source)\r\n\tat java.security.AccessController.doPrivileged(Native Method)\r\n\tat java.awt.Dialog.show(Unknown Source)\r\n\tat java.awt.Component.show(Unknown Source)\r\n\tat java.awt.Component.setVisible(Unknown Source)\r\n\tat java.awt.Window.setVisible(Unknown Source)\r\n\tat java.awt.Dialog.setVisible(Unknown Source)\r\n\tat dk.eobjects.datacleaner.gui.widgets.OpenDatabaseButton$1.actionPerformed(OpenDatabaseButton.java:40)\r\n\tat javax.swing.AbstractButton.fireActionPerformed(Unknown Source)\r\n\tat javax.swing.AbstractButton$Handler.actionPerformed(Unknown Source)\r\n\tat javax.swing.DefaultButtonModel.fireActionPerformed(Unknown Source)\r\n\tat javax.swing.DefaultButtonModel.setPressed(Unknown Source)\r\n\tat javax.swing.plaf.basic.BasicButtonListener.mouseReleased(Unknown Source)\r\n\tat java.awt.Component.processMouseEvent(Unknown Source)\r\n\tat javax.swing.JComponent.processMouseEvent(Unknown Source)\r\n\tat java.awt.Component.processEvent(Unknown Source)\r\n\tat java.awt.Container.processEvent(Unknown Source)\r\n\tat java.awt.Component.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Container.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Component.dispatchEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.retargetMouseEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.processMouseEvent(Unknown Source)\r\n\tat java.awt.LightweightDispatcher.dispatchEvent(Unknown Source)\r\n\tat java.awt.Container.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Window.dispatchEventImpl(Unknown Source)\r\n\tat java.awt.Component.dispatchEvent(Unknown Source)\r\n\tat java.awt.EventQueue.dispatchEvent(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpOneEventForFilters(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEventsForFilter(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEventsForHierarchy(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEvents(Unknown Source)\r\n\tat java.awt.EventDispatchThread.pumpEvents(Unknown Source)\r\n\tat java.awt.EventDispatchThread.run(Unknown Source)\r\n\r\nLooks to me like the index error deosn't release connection properly or something like that...
46	1	20	45	1215613929	kasper	Ah damn those open cursors ;-) I'll have a look at it asap.
47	1	20	46	1215614665	kasper	Hmm I can't really reproduce the scenario (my oracle doesn't seem to have the same problem, don't know why) so I will wait for your confirmation before releasing this ... Can you please try out this MetaModel jar?\r\n\r\nhttp://www.eobjects.dk/metamodel/MetaModel-1.0.2.jar
48	1	20	47	1215615188	anonymous	Nope, the error is still there...
49	1	20	48	1215615470	kasper	OK, I'm on my way out of the door right now, but I will look at again in a couple of hours and try to recreate the scenario "for real" so I won't have to use you as my beta-tester :) I'll post what I find out at least within the next 24 hours.
50	1	20	49	1215627298	kasper	Didn't manage to reproduce your error I'm affraid. I did however make some changes to the code that I '''THINK''' will do the job. Can you please try out this jar-file instead of the old one?\r\n\r\nhttp://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/MetaModel-1.0.2.jar\r\n\r\nWhat I did was to completely separate the column-searching part from the index-searching part of the code. That means that if the index-searching should somehow fail it will leave the column-part intact. I've also introduced a bit more strict cursor/resultset cleanup, even though the old one should have worked as far as I can see.\r\n\r\nIf it doesn't work, can you please then describe to me a little more about your database - what are the specific columns mentioned in the error message and how are your users configuration?
51	2	6	-1	1215677831	jasonfly	Hi,\r\nI was just looking for something like that. My only problem is that I don't see it in my portal. I am currently investigating why it doesn't work but if you have any idea. I suspect this has something to do with the JBoss Portal version ( I have 2.6.5 ). While I was writing this, I found the solution. You have to add the portlet-instances.xml file to the war. \r\nHere is the content:\r\n<?xml version="1.0" standalone="yes"?>\r\n<!DOCTYPE deployments PUBLIC\r\n   "-//JBoss Portal//DTD Portlet Instances 2.6//EN"\r\n   "http://www.jboss.org/portal/dtd/portlet-instances_2_6.dtd">\r\n<deployments>\r\n   <deployment>\r\n      <instance>\r\n         <instance-id>BirtReportPortletInstance</instance-id>\r\n         <portlet-ref>BirtReportPortlet</portlet-ref>\r\n      </instance>\r\n   </deployment>\r\n</deployments>\r\n\r\n\r\nAlso, it would be great to make it possible to use the repository to put the reports. If you can manage your reports through the CMS it would be great. I will look for that to be possible.\r\n\r\n
52	1	20	50	1215681770	anonymous	This is great - I finally was able to load everything correctly in Profiler. It took ages though as SYS schema in oracle contains a lot of objects that frankly one should not be looking at anyway. So is it possible to exclude some schemas from introspection (or at least an option to exclude SYS schema)? Generic solution could be loading schema metadata on demand, i.e. initially you load only schemas then when user clicked on expand in the tree - tables, but I that might not be possible if your metadata object is totally separate  from the GUI...\r\n\r\nAnyway its a good start and I already have a few suggestions about profiler which I'll describe in another thread...\r\n
53	1	20	52	1215691514	kasper	Glad to hear it worked!\r\nWe've already been working on some improvements to performance. The reason that the SYS schema takes ages to process is because it contains 1000-some views and only a couple (8 as far as I know) "real" tables. In DataCleaner 1.3 it will be optional to include views (with the default setting to just include tables).\r\n\r\nFor more info, see Ticket #171\r\n\r\nI'll release the new MetaModel version right away so the changes will become "official".
54	1	25	-1	1215691867	kasper	Thanks for the notice.\r\n\r\n * The scrollers have actually already been fixed, so look for it in version 1.3.\r\n * This really depends on the input, but the idea is good I think. For some tables it would be better to swap columns with rows, for other tables not. I have created ticket #172 to enable swapping/"dicing" of the tables.
55	2	6	51	1215692126	kasper	Hi jasonfly,\r\n\r\nIt's true, you can add the portlet-instances.xml file to automatically make an instance. What I've done was just to make the instance manually using the portals administration pages. I don't mind adding a portlet-instances.xml file in there though, but it's kinda jboss specific and the portlet was made to work in any JSR-168 compliant portal.\r\n\r\nThe idea about managing reports within the portal is also a great idea. I'm afraid we don't have too many people working on the portlet (ie. only me, and I'm quite busy with DataCleaner), so I don't think it's realistic unless we get more contributors though. Maybe you're interested in working on the portlet yourself?
56	1	25	54	1215692329	ItOnlyRains	Thanks. The reason behind having measures as columns is mainly for being able to sort on that (first and the most important question usually is which columns are the most empty ones and having 50 columns is not that easy to do that).
57	2	24	-1	1215692549	kasper	Hi jasonfly,\r\n\r\n 1. If you take a look at the viewReports.jsp file you can see that there are a couple of css classes that are used:\r\n  * fileParentFolder ~ the style class representing the icon to the parent ("..") folder\r\n  * fileFolder ~ the style class for a folder\r\n  * fileReport ~ the style class for a report\r\n  * You can use the [http://www.eobjects.dk/portal/ eobjects portal] and [http://www.eobjects.dk/resources/theme/eobjects.css it's css file] for inspiration :) This requires of course that you modify your portal theme to include the correct styles.\r\n\r\n 2. Can you elaborate a bit on what you're experiencing? The only idea I have at this point is that maybe you need to check the user-permissions of your folders. Make sure that the user who runs the jboss server has privileges to browse the folders that hold your reports.
58	1	20	53	1215692576	ItOnlyRains	Having option to filter out the views is good one, however it doesn't solve this particular problem with SYS views as I still want to be able to access the views in all other schemas apart from SYS ones...
59	1	20	58	1215693339	kasper	Ah yes. Hmm we'll have to implement lazyloading in the tree view then. That will require some changes, but I'll make a ticket for it and I hope it will make the 1.3 release then.
60	2	6	55	1215693584	jasonfly	Yes I am. I think it would be very helpful not only for me but for many other persons as well. \r\n\r\nMy big challenge is to put security in all this and I think that using the repository would be a great idea. I will investigate that.\r\n\r\nBut first I will try to understand how everything works in order to be able to make the changes. \r\n\r\nI have one question, do you have any idea if it is possible to tell BIRT Viewer that it has to take a file from something else than a local file? \r\n\r\n
61	2	6	60	1215694756	kasper	I'm afraid I don't have any real in-depth knowledge of the birt API, so no I don't know how to do that. For now the portlet doesn't include it's own birt viewer, it just generates URLs that will activate the "external" birt viewer to render the report.\r\n\r\nTo get you up and running as a contributor I need you to register your account at this site (the "register" link in your upper-right corner) and I'll give your user permissions to modify the BirtReportPortlet-code on SVN and some other stuff.\r\n\r\nAs an eobjects.dk developer I can recommend taking a look at these pages for information on the style and conventions of development:\r\n\r\n * HowToContribute\r\n * JavaCodingStandards\r\n * UnitTesting\r\n * ToolBase\r\n\r\nAlso, it would be great if you could register your work as tickets so we can track what is going on. I will try and help out as much as I can and of course support you with any questions etc. I will create a 2.0 milestone for which we can register the work to be done to the portlet.
62	2	6	61	1215695066	jasonfly	I created my account. I will take a look at the links and I will see what tickets to create.\r\n\r\nTalk to you soon\r\nHave a nice day\r\n
63	1	20	59	1216107468	kasper	Just a little notice. We're now done with the lazyloading tree ticket - you can [BuildingDataCleaner build datacleaner yourself] or wait for the 1.3 release to start using it :)
64	7	27	-1	1216364985	kasper	Hi there,\r\n\r\nYes absolutely. Have you tried them out using a JDBC driver? I'm not really experienced with those databases but if they are consistent with the JDBC spec and support SQL-99 queries, they should work.\r\n\r\nThis applies for all databases, not just the ones on the official [MetaModelCompliancy database compliancy] list. I will add DBF file support to the MetaModel 1.1 tickets so we can get absolute assurance on this though.
65	7	27	64	1216365583	kasper	Ah I see now that there are only commercial JDBC drivers available (at least if I only do a very quick google-search on it), but also some open source libraries to read the files - without JDBC.\r\n\r\nWe will definately make a !DataContext strategy to open these kinds of files, see Ticket #174.
66	7	28	-1	1216393745	kasper	Hi ybtan,\r\n\r\nThis is true and I've often thought about how to include support for XML files in MetaModel. As such MetaModel works with table-based data and XML files can have arbitrary structures, depending on the XML schema. I'm not aware of any generic way to map XML files to (two-dimensional) tables with columns and rows, so I'm not sure this is possible to do generically?\r\n\r\nThere is however the option to build your own implementation of [/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/IDataContextStrategy.html IDataContextStrategy] which is the interface that is used to retrieve data from a datastore and enable the functionality of MetaModel. If you want to implement a IDataContextStrategy for your XML files I would suggest you extend the abstract class [/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/QueryPostprocessDataContextStrategy.html QueryPostprocessDataContextStrategy] - basicly you would have to do the mapping of your XML-based file format in the populateTable method.\r\n\r\nIf you're thinking of some other way to map from XML files to tables that I'm not aware of, please let us know and we will of course implement it!
67	7	28	66	1216396147	asbjorn	XML schema is just denormalized relational data. So by reversing and normalizing the data it should be posible to support XML in metamodel as well. \r\nThere are however some issues regarding the use of element as attributes.\r\nIn the following example name should not be an additional table but address should. \r\n\r\n\r\n<persons>\r\n\t<person>\r\n\t\t<name>asbjørn</name> \r\n\t\t<address>\r\n\t\t\t<street>mystreet</street>\r\n\t\t</address>\r\n\t</person>\r\n</persons>   \r\n\r\n\r\n\r\nit could be solved by doing something like \r\n\r\n\r\n\r\nif(element.hasChildren()){\r\n    createTabel(element);\r\n}else{\r\n    elementAsAttribute(element);\r\n}\r\n\r\n\r\n\r\n
68	7	28	67	1216397302	kasper	Hmm yes I guess we could make some kind of normalization mechanism but we would be applying a lot of Xml-to-table mapping rules that may not be appropriate for all domains. But I guess we could give it a try and then review if it is generally usable.\r\n\r\nAlternatively we could perhaps make some kind of configuration based on XPath or similar, where the user/developer could specify mapping rules.
69	7	28	68	1216397725	asbjorn	I agree that it should be possible to make your own mapping. Automatic mapping is often a developers nightmare :( \r\n\r\nBut do you agree upon, that we need to normalize data?. As I see it metamodel is created to support DataCleaner even though it can have other purposes as well. In dataCleaner it doesn't make sense to make  e.g  a string analysis on a denormalized xml schema. \r\n 
70	7	28	69	1216397901	asbjorn	A wizard like mapping like the one used with flatfiles would be a good solution for me 
71	7	28	70	1216398215	kasper	Yes normalization is a requirement, but for general purpose (which is what we need to have in mind when developing MetaModel, it's not just a DataCleaner component) it may be better to only partially normalize, for example if there was a name-tag inside a person-tag:\r\n{{{\r\n<person>\r\n  <name firstname="kasper" lastname="sorensen">\r\n  <address>whatever</address>\r\n</person>\r\n}}}\r\nit would probably be better to just create a single table, but that's not something I think we could automate:\r\n * person (columns: firstname, lastname, address)\r\ninstead of three tables (which I believe is what should be the "default" setting):\r\n * person (columns: name_id, address_id)\r\n * name (columns: name_id, firstname, lastname)\r\n * address (columns: address_id, content)\r\nNotice also that we would apply some auto-generated ID's and we would have to name text-elements (in the case above, the address) by some kind of convention. In general - it's a tricky road but I'm sure we can overcome it :)
72	7	28	67	1216398741	ybtan	Thanks for your quick response.\r\n\r\nI see the difficulties in the XML generic parsing.\r\n\r\nBut if I want to add a complex type like "address" in the csv file, should I define it like this to illustrate the relationship between these two address columns?\r\n\r\nid,name,age,address.street,address.city\r\n\r\n1,ybtan,27,mystreet,mycity
73	7	28	71	1216398818	asbjorn	I agree that we need to make auto-generated primary keys. \r\n\r\nI also agree that in the specific example one table could handle all elements, but i think that just because my example being to simple. \r\n\r\nWe cannot make assumption regarding the use of attributes or elements as attributes. I think this is kind of a religious question. I see pros and cons in both solution, but this shouldn't be an xml discusion, thus we need to support both designs.  \r\n\r\nSo i think we should have a default setting, as you suggest. And as I suggested a wizard if you want to make your own mappings.\r\n\r\n
74	7	28	72	1216399092	asbjorn	As i see it the csv implementation, assumes that data are i a normalized form. But this is actual an interesting question, the xml problem could actual exist in csv files as well. 
75	7	28	74	1216401017	kasper	I think we should make an automated mapping mechanism first and then make it configurable as we go. There are potentially a lot of different preferences that one could have towards the mapping, just as there is a lot of configuration options in ORM-frameworks like Hibernate and if we go that far I think we're out of scope for MetaModel. Perhaps we should investigate if there are other Open Source projects concerned with normalizing/table-mapping XML files if we want to open up for very advanced mappings.\r\n\r\nOh yeah, and we can't provide a wizard for MetaModel, it's only middleware and has no UI. However we can make one for DataCleaner but that's a whole other issue that I don't think we should discuss here. What we can do is to provide configuration parameters to the XML !DataContext strategy that holds whatever values specified (perhaps by a wizard, depending on the application).\r\n\r\nI agree that the example was too simple to illustrate the real problem here - the real problem is that there is a multiplicity in XML children that doesn't exist in CSV, eg:\r\n{{{\r\n<person>\r\n  <name>kasper</name>\r\n  <address>My address</address>\r\n  <address>Another address</address>\r\n  <address>A third address</address>\r\n</person>\r\n}}}
76	7	28	74	1216401120	ybtan	I see.\r\n\r\nSo in order to represent the complex type in the csv, we should normalize it like:\r\n{{{\r\nid,name,age,addressid\r\n\r\n1,ybtan,27,1001\r\n}}}\r\n\r\nand:\r\n\r\n{{{\r\nid,street,city\r\n\r\n1001,mystreet,mycity\r\n}}}
77	7	28	75	1216401234	kasper	Or to make an even more complex example (that we can use for reference if either of you have more issues?):\r\n{{{\r\n<eobjects.dk>\r\n  <contributors>\r\n    <person>\r\n      <name>kasper</name>\r\n      <address>My address</address>\r\n      <address>Another address</address>\r\n      <address>A third address</address>\r\n    </person>\r\n    <person>\r\n      <name>asbjorn</name>\r\n      <address>Asbjorns address</address>\r\n    </person>\r\n  </contributors>\r\n  <projects>\r\n    <project name="datacleaner">\r\n      Here's a short description of DataCleaner, the the one for MetaModel is missing...\r\n    </project>\r\n    <project name="MetaModel" />\r\n  </projects>\r\n</eobjects.dk>\r\n}}}
78	7	28	76	1216401285	kasper	Yes that's right. That would be an "automated" normalization, but perhaps that's not the most convenient way for all domains.
79	7	28	78	1216401939	ybtan	Yes, that's my point.\r\n\r\nIn many legacy applications, their existent csv files or xml files are not so easy or convenient to exact their metamodels by current MetaModel. In those cases, MetaModel's function may be limited.\r\n\r\nWhat do you think?
80	7	28	79	1216404995	kasper	I don't think that the functionality is limited since those table can just be joined together to give the developer the same result. The good thing about MetaModel is that you can join (and other kinds of querying) those tables even though they are not natively queryable.\r\n\r\nI have added an XML support ticket (#176) for the MetaModel 1.1 milestone since I think that we've found some great insight into how we can normalize XML and I would love it if MetaModel could include such functionality.
81	2	6	62	1216411210	kasper	Hey jasonfly,\r\n\r\nAny news on this?
82	7	28	-1	1216456460	kasper	I've spent a little time trying to put this together and it's actually working quite alright, so I've comitted my changes in rev [477].\r\n\r\nCan you maybe check out the code and give a little feedback on if this is what you had in mind.
83	7	28	82	1216472572	ybtan	I have checked you committing, and I think it's good enough to deal with occasional XML files. \r\n\r\nHowever, I still have one little problem. That is, if we add this function to XML files, what's the place for the XML schema files, such as ".tld" file? Can we utilize these schema file for more accurate XML paring?
84	7	28	80	1216474717	ybtan	In my understanding to MetaModel project, we have such flows to build an application based on the common meta-model engine from MetaModel project.\r\n\r\n{{{\r\n                 Legacy Datastores(csv,xml,database,excel etc.)\r\n                           |\r\n                           |generic parse by MetaModel\r\n                           |\r\n                           v\r\n                 Normalized and mediate files(csv,xml,normalized database)\r\n                           ^\r\n                           |\r\n                           |import and use from MetaModel Context\r\n                           |\r\n                 meta-models in MetaModel(schemas,tables,columns)\r\n               &&data records basement(DataSets)\r\n                           ^\r\n                           |\r\n                           |datastore-neutral query API from MetaModel\r\n                           |\r\n                 Data Query Clients(other applications)\r\n\r\n}}}\r\n\r\nWe can not request the normalization to the file formats in the legacy datastore files. So I think this is the essential problem why it is difficult to deal with XML files. In the CSV etc. aspects, the problem will be still existent by using current MetaModel.\r\n\r\n> I don't think that the functionality is limited since those table can just be joined together to give the developer the same result. The good thing about MetaModel is that you can join (and other kinds of querying) those tables even though they are not natively queryable.\r\n> \r\n> I have added an XML support ticket (#176) for the MetaModel 1.1 milestone since I think that we've found some great insight into how we can normalize XML and I would love it if MetaModel could include such functionality.
85	7	29	-1	1216483363	kasper	Hi Rajesh and thanks for your interest.\r\n\r\nI honestly have close to little experience with LDAP so I wouldn't know how to build support for it but I'm open for suggestions! To extend MetaModel to be support LDAP we would have to implement the [/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/IDataContextStrategy.html IDataContextStrategy interface]. What I'm wondering is whether it is possible and appropriate to represent LDAP as a "Tables of Columns and Rows" oriented model?
86	7	28	83	1216483750	kasper	We COULD use the schema-files (xsd/dtd's) to improve some parts of the parsing (such as determining column datatypes, they are all Strings in the current version), but it would also make it significantly more complex to parse I think. Maybe there should be two seperate strategies for each kind of parsing (with a schema / guessing a schema).\r\n\r\nI did a little investigation and it seems also the eclipse BIRT project has a XML-to-table mapping mechanism. They basicly map each table and column to an XPath and then use that XPath to retrieve values. That's a third possible strategy I think.
87	7	28	84	1216484163	kasper	I'm still not sure I understand what you're saying :) I pretty much agree with your illustration of the MetaModel architecture, except that we don't use any mediate files. The queries are carried out according to the [http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/IDataContextStrategy.html IDataContextStrategy interface]. That means:\r\n * Queries to databases are executed using JDBC\r\n * Queries to CSV files use the internal query engine and materialize tables using OpenCSV\r\n * Queries to Excel spreadsheets use the internal query engine and materialize tables using Apache POI\r\n * Queries to XML files also use the internal query engine, but data is parsed using the DOM and are kept live in-memory.
88	7	28	87	1216486502	ybtan	I thought over my special requirement these days. Maybe some meta-layer wrappers should be implemented in the application. I think I can use MetaModel in my project now. \r\n\r\nIt's very helpful for me. Thank you for the kindness and  quick actions.\r\n\r\nKeep moving.
89	7	28	88	1216511805	kasper	Great, I'm glad it works for you and please don't hesitate to ask for anything!\r\n\r\nAlso, if you're using MetaModel in your project we would love to hear about it. As we are in the early stage of actually getting anyone to use this product it would be great with some user stories or maybe even a recommendation for the website?
90	7	30	-1	1216582937	kasper	Hi Vladimir\r\n\r\nI'm affraid that's not possible in version 1.0 of MetaModel. The reason for this has been to keep the query engine compatible with all datastores and such expressions mess up the object-oriented and type-safe evaluation of WHERE clauses. But now that you mention it I can see that this is probably a principle that we should reconsider because sometimes it's just more convenient if there's a way to "hack" the framework (with the possibility of errors in the expression of course). Either that or we should implement a new kind of !SelectItem that contains calculated values, like "c.ip1 & 12" or "product.price_cents * 100 AS price_euros".\r\n\r\nOn another note, what does the "&" operator do? I haven't come across that syntax in SQL 99 before.
91	7	30	90	1216594386	marten.ola	if you just want a quick fix you can just create a new class that extend Filter Item with a new constructor and overload the toString method!
92	7	30	90	1216632980	antiso	Hi Kasper,\r\n\r\nThe compatibility with wide range of engines is a really exciting feature. My note was just about the case I've met. Moving such expression to SELECT section will increase "intellectual" requirements to DB optimization engine.\r\n\r\nThe "&" operator is a bitwise AND in MySQL, MSSQL, ...
93	7	30	91	1216633806	antiso	Thank you for reply. \r\n\r\nI'm just evaluating MetaModel as a DB independent query production layer. Seems like the way you mentioned is good enough for me. Another issue is where to plug code that will convert used DB engine specific functions to another DB engine. It will be useful if user of MetaModel uses some particular functions that have different names or format in other engines.
94	7	31	-1	1216667493	asbjorn	For now MetaModel is a read-only framework. We have chosen this limitation to avoid the complexity of handling different dialects
95	7	30	92	1216715572	kasper	Hi antiso,\r\n\r\nYou're right, it would make MetaModel more usable for developers with detailed query requirements like yours. MetaModel 1.0 was create using a "80/20" line of thought but we will of course broaden the functionality in future versions and for a start we can make it possible to inject custom !SelectItems for JDBC-based !DataContexts.
96	7	31	-1	1216716252	kasper	The difficulty with creating tables, inserting and updating is also that not all the support datastore types are modifyable in comparable ways. CSV files for example can only contain a single table. Of course this is not a reason that we should not contain write-operations within MetaModel and we've often discussed how it could be done but in essence the framework has been created for investigation and querying of different datastores. Writing to the datastores is a future, visionary idea that we will implement eventually but not right now, unless someone has the urge and great ideas to do so of course! :)
97	7	32	-1	1216731553	kasper	The quoting character is retrieved using the JDBC API. You can get it by using:\r\n\r\n{{{\r\nmyConnection.getMetaData().getIdentifierQuoteString()\r\n}}}\r\n\r\nI have just added ticket #177 to take care of this issue. Thanks for the notice!
98	7	32	97	1216733145	antiso	> The quoting character is retrieved using the JDBC API. You can get it by using:\r\n> \r\n> {{{\r\n> myConnection.getMetaData().getIdentifierQuoteString()\r\n> }}}\r\n> \r\n> I have just added ticket #177 to take care of this issue. Thanks for the notice!\r\nI haven't found a way to get connection from either !SelectItem or it's subclasses. The only way to get quotation symbol is to do following call:\r\n{{{\r\n_query.getFromClause().getItem(0).getTable().getQuote();\r\n}}}\r\nSo, the question is: Is it true that _query can't be null at the moment of call !SelectItem.toString() ?
99	7	32	98	1216733448	kasper	Once the !SelectItem is added to the query, the _query field is set (and thereby not null). But the code that you describe could throw a !NullPointerException if !FromItem no. 0 isn't a table-based !FromItem (it can be a join or a subquery as well).
100	7	32	98	1216733623	kasper	Instead you should consider using\r\n{{{\r\nMetaModelHelper.getTableFromItems(Query q)\r\n}}}\r\nIt will retrieve all the !FromItems in your query (including traversing subqueries and joins) that are based upon tables. That will make your code a bit more robust. But I would recommend waiting for Ticket #177 ...
101	7	32	100	1216739625	antiso	Thank you for your explanation. I'll wait for ticket #177
102	7	33	-1	1216742444	kasper	While most databases are case insensitive I believe that there are some DBMS's where it's actually possible to create two independent tables that share the same name, just in different cases. And in turn Java is traditionally a pretty case sensitive language. What I think we should do was to make it case insensitive unless more than one match is found, then only case sensitive matches are returned. I'll post a ticket for it right away.\r\n\r\nTell me antiso, you bring a lot of suggestions - are you interested in contributing to (ie. by co-developing) MetaModel? We could always use more developers and it sounds as if you're already pretty involved with the project.
103	7	33	102	1216744872	antiso	Kasper,\r\n\r\nI can contribute to this project. It will be really nice to get issues fixed as they arise. If spending 4-10 hours a week is acceptable by process used in MetaModel development then I can start.
104	7	33	103	1216749458	kasper	Sure, 4-10 hours a week is by far enough. I have given you some additional permissions on this site, giving you more ticket-editing options. Make sure to post tickets about the issues you want to work on and keep us updated by posting ticket-updates. We value UnitTesting very highly on the MetaModel project so I hope you're familiar with this?\r\n\r\nFor the first couple of contributions please post your code as patches (just attach it to the tickets) and we'll review it together so we sure to get a good start. After that we'll grant you write-permission to the SVN repository. A couple of pages of interest:\r\n\r\n * CreatingPatches\r\n * HowToContribute\r\n * ToolBase\r\n * UnitTesting\r\n\r\nPS: I've posted a ticket for the case-insensivity issue: #179
105	7	34	-1	1217088320	kasper	Hi antiso,\r\n\r\nNo, you're right, IN is not yet a part of the supported Query model. It would definately be a great thing to build into it though. For clarity I will create a paragraph in the [MetaModelDevelopersGuide developers guide] on the available functionality in the Query model.
106	7	34	105	1217089683	antiso	Should be IN implemented for ALL supported !DataContexts?
107	7	34	106	1217090172	kasper	As a base thought, yes. The query model should be generic, thus have general applicability. There are however already a few deviations to this rule; RIGHT and OUTER JOIN is not yet supported for csv/excel/xml data, but will be soon. To begin with we COULD thus just implement IN for JDBC datastores and then throw Exceptions if it occurs in other kinds of datastores.
108	7	34	107	1217091182	antiso	What do you think about using some embedded RDBMS(Derby, HSSQL) as a backend for processing of csv/excel/xml? There is very fast generic support for bulk upload of csv files and stream converters for other 2 could be implemented more easily than queries engine. This will allow to use good enough DB engine to support different operations type and functions for processing.
109	7	34	108	1217091710	kasper	Thats a pretty good idea I think. I would have to vote for HSQLDB then, because we include it already for !OpenOffice database support. That being said, if you have a look at the [/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/QueryPostprocessDataContextStrategy.html abstract query postprocessing strategy] it's not all that complicated to make those datastores work with the built-in query engine. I don't really have any idea about what works best, performance-wise though.
110	1	25	-1	1217165625	kasper	Hi ItOnlyRains,\r\n\r\nFor your interest we've just released 1.3 of DataCleaner and it contains the features that you speak of :)
111	1	17	24	1217165712	kasper	For your interest, we've just released version 1.3 of DataCleaner with those improvements that you've inspired us to do (but now in a stable, supported version).
112	7	34	109	1217194563	antiso	Does it worth to file a ticket?
113	7	34	112	1217232786	kasper	Yes definately. The ticket is a good way to keep track of work and collect the relevant information on an issue, helping the "self-documentation" of the software. Also, we use the ticket numbers in our [/trac/timeline?from=07%2F28%2F08&daysback=7&changeset=on&update=Update SVN commit-messages] in order to keep track of code revisions.
114	7	34	112	1217234883	kasper	Just to give you a little guidance on the process... First thing we do is post the ticket, I think you should do that since it's your original suggestion. Then we start discussing how to solve it and perhaps developing on it.\r\n\r\nOne thing I think we need to find out in this particular ticket is how the IN operator should work, API-wise. I imagine that we will need to make a new constructor for the [/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/FilterItem.html FilterItem] that takes a query as the operand argument, ie:\r\n\r\n{{{\r\nSelectItem someSelectItem = ...\r\nQuery someSubQuery = ...\r\nnew FilterItem(someSelectItem, OperatorType.IN, someSubQuery);\r\n}}}\r\n\r\nOn the other hand I'm beginning to feel that these constructors are no longer self-explaining and the IN operator is somewhat different than the other operators, so perhaps something like this would be better:\r\n\r\n{{{\r\nFilterItem.in(someSelectItem, someSubQuery);\r\n}}}\r\n\r\nOr even better, making the !FilterItem interface fluent (higher workload, though):\r\n\r\n{{{\r\nnew FilterItem(someSelectItem).higherThan(15)\r\nnew FilterItem(someSelectItem).equalsTo(null)\r\nnew FilterItem(someSelectItem).in(someSubQuery)\r\n}}}\r\netc...\r\n\r\nAre there any situations where one would use IN on something else than a subquery? Perhaps a hardcoded list of values?
115	1	35	-1	1217337560	kasper	On another note, I found this website, which contains a lot of official data about danish geography, companies etc.:\r\n\r\nhttp://www.informationsportalen.dk/databaser/baser/index.htm\r\n\r\nPerhaps there are similar portals around for other countries?
116	7	36	-1	1217447158	kasper	Hi scorreia,\r\n\r\nNo I'm afraid these queries are more advanced than what can be handled by MetaModel. The reason is that there's an extensive use of functions that are not cross-database compliant in your example queries, ie. OVER(), TO_NUMBER, ROW_NUMBER() etc.
117	7	36	116	1217493440	scorreia	Hi kasper,\r\n\r\nI currently use ZQL (http://www.gibello.com/code/zql/) for parsing my queries. But it also fails on these queries although you can add specific functions with any number of argument. \r\nFor example, ZQL can handle queries with TO_NUMBER() but not the particular structure of queries with OVER() for example. \r\nAlso, for MySQL, it cannot handle the LIMIT clause because it is not standard and it is not a function neither. \r\n\r\nDo you plan to enhance your MetaModel to support non standard SQL queries or will you keep it only for standard SQL?\r\n\r\nFor me, support of database specific queries is important because there is more and more statistical functions implemented by databases and these functions can be used in data quality tools. \r\n\r\nWhat would be the best: a parser for each database with its specific grammar or a generic parser which could be enhanced with add-ons. \r\nI am not familiar with parser development, but from what I have seen, the best is probably to generate a parser for each database. What is your opinion about that? \r\n
118	7	36	117	1217494111	kasper	Hi scorreia,\r\n\r\nWell to be precise, MetaModel is not a parser. It's true that we have been working on another project, QueryParser, which is - but it's still very early stage. So in that sense ZQL and MetaModel is two pretty different projects.\r\n\r\nThe strong thing about MetaModel is that there's a tight integration between the schema model and the query model - you make type-safe queries based upon the schema model, not based upon String literals. So the intention in MetaModel wasn't to be a parser of String-based queries (we can assume that they work just fine already) but to make it easier and more robust to define new queries.\r\n\r\nRegarding the database-specific functions etc. I don't think it will be in our immediate interest to support them as it was never the purpose of MetaModel - the purpose was to make it easy to switch between datastores and gain a "common ground" for these. If you want database-specific SQL parsers I can suggest looking at some of the open [http://antlr.org/grammar/list antlr's grammars], I know there are various db-specific ones for Oracle, MS and probably more.
119	4	37	-1	1217527710	kasper	Hi Manjunath,\r\n\r\nMetaModel and Hibernate are answers to different questions you might say. Here's a short overview of the general difference:\r\n\r\n * Hibernate is an O/R mapping framework which means that the "input" in Hibernate is your domain model - an object-oriented model of your domain that you wish to map against a database.\r\n * MetaModel on the other hand is NOT an O/R mapping framework. It is in itself a domain model for the datastore domain. What this means is that it's appropriate to use MetaModel for applications that have the datastores as the ''domain itself''. This is why it's called "!MetaModel" - it's a "model of (data) models". You would typically use MetaModel for applications that should work across different datastores (ie. database clients, ETL-tools, database analyzing applications etc.), for example DataCleaner, TableAgent etc.\r\n\r\nSo to answer your question - MetaModel is not ''better'' than Hibernate since they work on different levels. Hypothetically a large part of the Hibernate framework could have been implemented using MetaModel, but this is not the case of course since MetaModel is very new.
120	7	38	-1	1217547635	kasper	Hi Porter,\r\n\r\nThanks for the suggestion and I agree totally... This is something that we should fix for the next minor release (1.0.4 I believe) as it's really simple and a nice syntax fluency improvement. I'll post a ticket for it right away.\r\n\r\n/Kasper
121	1	35	-1	1217558115	SantaClaus	A full list of all Danish female first names, male first names and last names is available from the Danish statistical bureau. They charge a fee for delivering.\r\n\r\nThis list also contains a frequency for the names which is useful in an intelligent way of validating names.\r\n\r\nFurther more the list contains the age distribution for the first names. This is useful if you want to give a probabilistic value about the age of a person with a given name – say the probabilistic age of male called ‘Kasper’ is 22, and the probabilistic age of a male called ‘Børge’ is 77.\r\n\r\nSimilar lists are available from the Swedish and Norwegian statistical bureaus.\r\n
122	1	8	-1	1217559631	SantaClaus	Duplicates in names and addresses are one of the most prominent data quality issues around. \r\n\r\nThere are a couple of different approaches to find duplicates in names and addresses:\r\n\r\nSynonyms: This is in my eyes the most basic approach. You have a list of common translations to different words like common misspellings, nicknames and so on. This approach is of course very depending on heavy maintenance, and must be worked over for every language/country – and actually works better with English than other languages like the Germanic ones, where you use concatenated words (like ‘Main Street’ being ‘Mainstreet’).\r\n\r\nMatch codes: You find those from very simple ones to the more sophisticated ones – going from ignoring vowels, soundex and metaphone (for English) to proprietary findings of all kinds. In my eyes match codes works OK for selecting candidates for matching – but falls a bit short when coming to actually settling the case.\r\n\r\nAlgorithms: A complex algorithm seems to be the only secure way to actually settling if two different spelled records make up the same real world entity. You have to deal with truncations, non phonetic typos, rearranged words and letters and all that jazz.\r\n\r\nProbabilistic learning: This is at bottom a variation of synonyms, but the collection is not based on up front maintenance but collection of users actual decisions when verifying automatic matching. You may register the frequency and context of the decisions and combine with match codes and algorithms. This of course requires a substantial collection. \r\n\r\nAll approaches may of course be combined – and parsing and standardisation (a topic of its own) is often a supplementary method when you dedupe.\r\n\r\n
123	1	8	122	1217571773	kasper	Hi !SantaClaus\r\n\r\nThanks for the input, those are some interesting approaches and I have added them (or rather, this discussion thread) to the ticket description (Ticket #105) for us to use when implementing the duplicate records profile.
124	1	35	121	1217571900	kasper	Great, I'll add this info to ticket #25!
125	7	38	120	1217619741	kasper	FYI, we've fixed this (#185) as of rev. [490]. Once again, thanks for the suggestion.
126	1	20	63	1217818779	BenBor	I am not convinced that this problem has been solved in 1.3.  But I may be wrong.  Here's what happens:\r\nI have installed V1.3 and I am using it against an oracle database.\r\nI can see all the schemas (it's a large Data Warehouse, probably 100 difference schemas).  When I click on a schema that owns a small number of tables, there is no problem and everything works.  But when I click on a schema that owns many tables, everything freezes, with no error message anywhere (at least, nowhere obvious).\r\nThe schema I am trying to access is the main schema of the data warehouse, and includes 1042 tables.\r\nIn data warehousing terms, this is large but no amazingly large.\r\n\r\nCan anyone offer any workarounds?
127	1	20	126	1217834492	kasper	Hi BenBor,\r\n\r\nHonestly, we haven't tested it with that many tables but I did experience some lag-time when opening the one of the system schemas that holds a little over 100 tables as far as I recall. I'm pretty convinced that if you wait a little while, you'll eventually get a working app, but this is of course not acceptable performance-wise. One thing I'm thinking is that perhaps the "thin" driver is not appropriate for this kind of operation? I'm no Oracle expert but they have different types of JDBC drivers and perhaps some of them are better for more performance-intensive operations?
128	1	20	126	1217835482	kasper	Uh one more thing, can you check the console for any error messages? I was just going through the code and discovered that our error handling ''if'' anything was to go wrong was not that good in just that part of DataCleaner so I'll file a bug for improving that right away.
129	1	20	126	1217836845	beno	Did u try to only select tables or views, not both?
130	7	38	125	1217873714	Porter	Very cool.  That was really the only thing that struck me - I had picked up the Second Edition of "Effective Java" (since the 1st edition was so good) and I'm trying to take a lot of the advice to heart there.  Not to mention the thousands of other posters on the 'net who (rightly) point out that over it's lifetime, code is read more than it's written.\r\n\r\nI really dig the fluent interface for building queries.  Thanks for being open to suggestions.
131	7	38	130	1217882335	kasper	Glad you like it :) Speaking of fluent interfaces, you might wanna check out [http://kasper.eobjects.dk/2008/08/considering-metamodel-functions.html my recent blog post] about the interface issues of adding new functionality to the query model.
132	1	20	129	1217885831	BenBor	 1. I tried selecting tables only.  Tried selecting views only.  Neither work.\r\n 2. I waited for over half an hour, still no response.  My "Task Manager" shows almost no CPU activity, so I assume that the profiler is not doing anything.\r\n 3. Well, after about half an hour the console displayed an error message \r\n{{{\r\n“WARN  JdbcDataContextStrategy - Could not retrieve index info for table: FACT_IMMUNISATION_SUMMARY\r\nINFO  JdbcDataContextStrategy - ORA-01502: index DSSADM.FACT_IMMUNISATION_SUMM_IDX_0' or partition of such index is in unusable state”\r\n}}}\r\nI deduce from that that (1) it is still running, and (2) the program loads all the metadata information for all the tables at this time, instead of just loading the table names and populating the rest of the metadata when a table is selected.  Wouldn’t it be better to do it the other way?  Load just the table names, thus making them visible.  When a user selects a table for profiling, load the rest of the metadata.  There is still no resposne from the GUI, though.  I'll wait another hour, I guess...\r\n 4. Kasper - you have been in contact with the Talend people, who are also developing a Data Profiling tool.  They seemed to have solved this problem and their schema browser opens my schema with no perceptible delay.  I think that your measures are better, though.  A combination of both tools would be nice.\r\n 5. I am a very experienced Business Intelligence, Data Warehousing and Data Quality consultant.  I currently have some time to 'play' with Data Quality tools.  Would you be interested in a list of improvement suggestions?
133	1	20	132	1217887164	kasper	I took the liberty of formatting your reply a bit to make it look nicer with our website :) If you want formatting tips, you can check out: WikiFormatting. I'm going to try and reply to your comments one by one :)\r\n\r\n 1. OK, but I guess it's also not satisfactory to just rule out views or tables.\r\n 2. I think you can shut it down now :)\r\n 3. This is really the interesting part. Your assumptions are right as with the eager loading of metadata and I guess we could perhaps tweak that part a bit but it's not really the issue and since we use MetaModel as our data access component this is not just a matter of how the tree works but how the model for the whole app works. In order to get closer to diagnosing this problem, can you please inform me of:\r\n  * What version of Oracle you are running\r\n  * What JDBC driver you're using\r\n  * The structure of the DSSADM.FACT_IMMUNISATION_SUMM_IDX_0 index. This is crucial I think so all the info you have please.\r\n  * The structure of the FACT_IMMUNISATION_SUMMARY tables, including indexes, foreign and primary keys.\r\n  * If it's possible, a little .sql script with a snippet of the table would be best, then I'll create an exact copy of your scenario and will have the best ways of testing it.\r\n 4. I agree that there are strengths and weaknesses in both projects and we are talking with them on ways we can collaborate, but I don't believe we'll see that the projects merge. We will however probably coorporate on some of the data quality "input" such as regexes, dictionaries etc.\r\n 5. We're always open ears for new ideas. And if you want to help us along a lot of things can be done of course. Our project structure is informal and if some one has an idea that they want to work with we won't stop them unless it interferes with other plans.
134	1	20	133	1217893931	BenBor	 1. Probably irrelevant to ''this'' discussion, but I am not sure why you would want to profile views.[[BR]]\r\n 2. Surprisingly, after over an hour, it all came back and is now working.  I don't dare exit, though :)... it will take another hour to get back to where I am... Will I ever shut-down my machine again? :-)\r\n 3. I am using Oracle 9.2, JRE 1.6.  The full table creation script is almost 27,00 lines (!).  Mainly to do with partitioning and index partitioning.  If you want, I can email you the script.  Placing it on this Wiki is not going to make me too popular, I guess.\r\n\r\nI hope this helps.
135	1	20	134	1217922528	kasper	 1. I agree, normally you won't profile views. But to some users it may be easier to get an overview of their data by looking at the views - The only example I can come up with is for the Javascript evaluator, it would be beneficial to create a joined view if you where to check the integrity of two columns from different tables, then you could reference the joined values in the same javascript.\r\n 2. I think you can shut it down - at least I'm pretty sure we'll overcome this bug eventually, even though it has been a pain in the a...\r\n 3. Yes please email it to me at kasper@eobjects.dk then I'll give it a go. I'm running Oracle 10g (Express) but hopefully it will let me recreate the scenario.
136	1	20	135	1217957919	scorreia	Hi, \r\nI join this discussion only to ask one thing:\r\nWhy wouldn't you profile views? \r\nOften views are defined in order to not bother business users with too many details. And profiling them allows the business users to check the quality of the data they are using. \r\nSometimes business users even don't have access to the tables, but only to the views defined for them. 
137	1	20	136	1217960554	kasper	I agree with that also :) I think the line of thought by some may be that they think of tables as the "sources to views" and then may feel uncomfortable with doing DQ analysis on behalf of the result as apposed to the source. If you profile or validate a table you'll get results that apply directly to the table your working with. If you want to make corrections to a view you'll have to find the actual table and do the corrections there.
138	1	20	137	1217961333	scorreia	Of course, if you want to clean the data, you will need to work on the tables. \r\nBut this does not mean that the profiling has to be done on the tables. \r\nFor example, where I worked before, developers of Business Object universes could only work with views. Then in order to check the quality of the data they deliver in their BO reports, they had to profile the views because the views were the source of the final reports. 
139	1	20	138	1217970971	BenBor	I fully agree that in the scenarios you describe it is sensible to profile a view.[[BR]]\r\nHowever, I would not recommend these scenarios.  If an organisation is serious about Data Quality, it should have a Data Quality expert who performs the profiling, formats the results into plain English (or whatever the local language is) and discusses it with the business.[[BR]][[BR]]\r\nI would '''not''' expect users to do their own data profiling.
140	1	25	110	1218027472	ItOnlyRains	This is great! Looks much better.
141	1	20	-1	1218179083	kasper	For reader's interests: We've identified that choosing the [http://www.oracle.com/technology/software/tech/java/sqlj_jdbc correct JDBC driver] version (the same as your oracle server) is very important. This ruled out the main part of the problems that BenBor had been experiencing and we're working on the last couple of minor bugs.
142	7	40	-1	1218612617	kasper	You need to fetch the data1 column thru your table instead of instantiating a new column. Eg. customerTable[0].getColumnByName("data1") or getColumns()[1]
143	7	40	142	1218642674	Radgon	Thanks a lot, that works!
144	7	32	-1	1219068904	kasper	Hi antiso,\r\n\r\nI'm happy to tell you that we've released MetaModel 1.0.6 where ticket #177 has been fixed. You can get it from the maven repo shortly or [http://datacleaner.sourceforge.net/m2-repo/dk/eobjects/commons/MetaModel/1.0.6/ download it directly] from our repo mirror.\r\n\r\nI will also make it available at our [http://code.google.com/p/metamodel/downloads/list google code download site] but I'm experiencing an unavailable upload service so I'll try again later.
145	7	40	143	1219068959	kasper	You're very welcome and excuse me for the short answer, I was on my vacation and trying to type it in on my cellphone ;-)
146	4	41	-1	1220350029	kasper	Hi beno,\r\n\r\nWe are experiencing some delay in domain registration and DNS updates so this is the reason that the domain name has not been activated yet. But you're right - it was a bit too eager of me to start updating the wiki pages with new URLs because those are actually not available yet. I will not do any further updating before we have an available domain name. Sorry for the inconvenience.
147	4	41	-1	1220397700	kasper	There you go, should be fixed now :)
148	3	2	-1	1220942612	edwin_herald	I want to contribute as a developer for this open source project.\r\n\r\nCan you guide and assign me some tasks>\r\n\r\nRegards, Edwin
149	3	2	148	1220943547	kasper	Hi Edwin,\r\n\r\nSure it's always great with new contributors! By "this project" I assume you mean DataCleaner? I think the shortest path towards contributing is something like this:\r\n\r\n * Sign up for the MailingLists to get into the "contributor-loop".\r\n * Check out the code (there are some instructions in the BuildingDataCleaner article), as of today we've added a lot of TODO tasks and a todo.txt file in the core project, I suggest you can start by taking a look at some of those tasks.\r\n * Communicate. Please let us know what you do, either here on the website or on the mailing list. And please ask if you have any questions!\r\n\r\nI hope to hear from you again, we can always use more people so I'm glad you asked.
150	3	2	149	1220963160	edwin_herald	Hi Kasper,\r\n\r\nThanks for steps to setup Datacleaner.\r\n\r\nI have done the below things\r\n\r\n{{{\r\n1svn export http://eobjects.org/svn/commons/MetaModel/trunk MetaModel - Done\r\n2svn export http://eobjects.org/svn/datacleaner/DataCleaner-core/trunk - DataCleaner-core - Done\r\n3svn export http://eobjects.org/svn/datacleaner/DataCleaner-gui/trunk DataCleaner-gui - Done\r\n4.Installed Maven to build Datacleaner\r\n5.While building using mvn clean install, it throws below error like\r\n\r\n[INFO] ------------------------------------------------------------------------\r\n[ERROR] BUILD ERROR\r\n[INFO] ------------------------------------------------------------------------\r\n[INFO] Failed to resolve artifact.\r\n\r\nGroupId: org.apache.maven.plugins\r\nArtifactId: maven-clean-plugin\r\nVersion: 2.2\r\n\r\nReason: Unable to download the artifact from any repository\r\n\r\n  org.apache.maven.plugins:maven-clean-plugin:pom:2.2\r\n\r\nfrom the specified remote repositories:\r\n  central (http://repo1.maven.org/maven2)\r\n\r\n\r\n[INFO] ------------------------------------------------------------------------\r\n[INFO] For more information, run Maven with the -e switch\r\n[INFO] ------------------------------------------------------------------------\r\n[INFO] Total time: 27 seconds\r\n[INFO] Finished at: Tue Sep 09 17:52:05 IST 2008\r\n[INFO] Final Memory: 1M/2M\r\n[INFO] ------------------------------------------------------------------------\r\n}}}\r\nI think it fails due to some dependent jar files missing, can you please let me know what are they?\r\n\r\nRegards, Edwin
151	3	2	150	1220963706	kasper	Hi Edwin,\r\n\r\nYou're almost right. It says that it can't find the "clean" plugin for maven, which it tries to download from the central maven repo (repo1.maven.org/maven2). \r\n\r\nThis is probably because you are accessing the web behind a proxy or similar? If this is the case, you need to do is to edit the settings.xml in your maven '''conf''' folder and supply a <proxy> tag, I believe there's an example in the file's comments.\r\n\r\nAfter you've corrected your settings you need to delete a little maven metadata because when maven doesn't find it's plugins it sometimes blacklists that item! So you need to go to your repository folder (in windows, typically C:\\Documents and Settings\\[username]\\.m2\\repository, unless you specify otherwise in the settings.xml file) and delete the org/apache folder.\r\n\r\nI hope it works out.
152	3	2	151	1221035849	edwin_herald	Thanks Kasper,\r\n\r\nNow I am able to clean build Metamodel successfully.But while building Datacleaner-core, I am getting below files missing for download.\r\n\r\n{{{\r\n[INFO] ------------------------------------------------------------------------\r\n[ERROR] BUILD ERROR\r\n[INFO] ------------------------------------------------------------------------\r\n[INFO] Failed to resolve artifact.\r\n\r\nMissing:\r\n----------\r\n1) rhino:js:jar:1.7R1\r\n\r\n  Path to dependency:\r\n        1) dk.eobjects.datacleaner:DataCleaner-core:jar:1.4-SNAPSHOT\r\n        2) rhino:js:jar:1.7R1\r\n\r\n2) com.google.code.google-collections:google-collect:jar:snapshot-20080530\r\n\r\n  Path to dependency:\r\n        1) dk.eobjects.datacleaner:DataCleaner-core:jar:1.4-SNAPSHOT\r\n        2) com.google.code.google-collections:google-collect:jar:snapshot-20080530\r\n\r\n----------\r\n2 required artifacts are missing.\r\n\r\nfor artifact:\r\n  dk.eobjects.datacleaner:DataCleaner-core:jar:1.4-SNAPSHOT\r\n\r\nfrom the specified remote repositories:\r\n  central (http://repo1.maven.org/maven2)\r\n}}}\r\nI think 2nd artifact I can download from google but the 1st artifact from where i can download it? \r\n\r\nThanks
153	3	2	152	1221039520	kasper	Both those jars (rhino and google-collections) should be available at the public maven repository so you don't need to go to any websites to download them. I think what has happened is that since your first attempts to build with maven failed due to your proxy settings, then several jars was blacklisted. The easiest (but potentially also a bit heavy on internet traffic) solution to this kind of problem is to remove your local maven repository completely (ie. your /.m2/repository directory).\r\n\r\nI don't know if there's an easier way, God knows that this is something that I've been cursing about for some times now, but unfortunately I didn't invent Maven (and besides those blacklisting issues I think the build system is pretty great).
154	3	2	153	1221043474	edwin_herald	Yes, I have fixed all the issues.\r\n\r\nNow I am able to run the application.I think it requires some time to understand the tool inorder to start working on the task.\r\n\r\nIn the meanwhile, please expalin briefly about the ticket #214\r\n\r\nThanks
155	3	2	154	1221046981	kasper	Glad you got it up and working :) I agree that Maven takes some time to understand, and I'm very sorry you had a hard time getting it to work, but once you get used to it you don't want to go back, I can assure you :)\r\n\r\nI've updated ticket #214 with some instructions but please ask away if you have questions (but lets discuss the ticket issues in the ticket comments or on the mailing list, instead of here).
156	3	2	-1	1221507670	losilante	Ciao to all.\r\n\r\nMy name is Paolo and I live in Verona Italy.\r\nI'm willing to contribute as a developer for this open source project. \r\nI've had a short Java exp before now I'm studying to take the Sun Java programmer certificate (SCJP) Exam so I think I can help (a bit) and learn (a lot).\r\nI see it's not only about Java : there are some other things around wich have to be considered.\r\nI'm starting to have an idea of what MAVEN is , I manage a little better with\r\nSVN; some other acronyms are still obscure ; I've read the coding standards and I'm browsing the source code.\r\nI think I'll need some more time before I can be of any help.\r\nI've already contacted Obi One (Kasper) wich very kindly introduced me to the\r\nfirst tasks.\r\nFirst of all I have a little doubt : is it ok if I use NetBeans IDE instead of  Mr. Eclipse ?\r\n\r\nsecond : since I am totally new to a open source project I'd like to have a brief explanation of the "modus operandi" of the developing (programming) process that is , in english , in wich way to proceed to do things.\r\n\r\nOk, that's all for the moment .\r\n\r\nCiao a tutti. (hello everybody).\r\n\r\nPaolo\r\n\r\n
157	3	42	-1	1221509162	kasper	Hi Coffee Logos,\r\n\r\nThanks for your interest in DataCleaner! I don't know if you know it, but we are actually considering new logos right now - you can follow along (and participate) in the development of the new logo at Ticket #212.\r\n\r\nWhen I click the logo you have provided I get a "You are not authorized to view this album" error message - can you please upload the proposed logo to Ticket #212 so everybody can evaluate it?
158	3	42	157	1221509731	Coffee Logos	Yes I'd be happy to.
159	3	2	156	1221510460	beno	Hey Paolo,\r\n\r\nDid you check out the HowToContribute page? Here's a snippet with the "modus operandi" although I think it's not that formally in practice:\r\n\r\n * Someone has an idea for a new feature and posts his/her idea on the MailingLists or reports it as a [/newticket new ticket].\r\n * After some time of refinement of the new feature through discussion, a trac ticket describing the features is created. More info: TracTickets.\r\n * Unittests are implemented to describe the technicalities of the feature. More info: UnitTesting.\r\n * The feature itself is implemented to satisfy the unittests. More info: ToolBase and JavaCodingStandards.\r\n * The contributor/implementor creates a patch with his or hers contributions and replies to the trac ticket with the patch as an attachment. More info: CreatingPatches.\r\n * Unittest and feature code is reviewed by project owner(s).\r\n * Unittest and feature code is submitted to subversion.\r\n * If any issues arise, they are dealt with just the same way as new features, beginning with a unittest to document the issue.\r\n\r\nI would say that it makes no difference whether you use Netbeans or Eclipse because you only contribute code patches, whose contents is not IDE dependent.\r\n\r\nI saw the other day on the mailing list that kasper had introduced some TODO javadoc-comments in the code for first time contributors, I think some of those would be appropriate for you to begin wtih!
160	1	43	-1	1222151863	kasper	Hello beno,\r\n\r\nYes this is really something we could use. I agree we should have more dictionaries included in DataCleaner and this is also something I think we will intensify a lot the next couple of months. If I could get you to attach them as text files to ticket #25 then it would be great!
161	1	43	160	1222152757	beno	I've uploaded the dictionaries that I had. I also included a US states list and took a little time to find the last names for US also. Now I'm off to bed, nightie :)
162	1	43	160	1222153034	beno	For reference, you can find US names here:\r\n\r\nhttp://www.ssa.gov/OACT/babynames/\r\n\r\nI just used the most popular names of 2007 but actually I'm thinking if that may have been a bad decision - I mean, it would be best with a population-based number instead of the newborn one.
163	1	43	162	1222158618	kasper	Thank you very much beno!\r\n\r\nRegarding the baby names I will try and look for other sources for this information and make a merged dictionary out of them then. Thanks for the contributions.
164	1	44	-1	1222328358	kasper	Hi vipinmishra,\r\n\r\nThe [http://java.sun.com/j2se/1.4.2/docs/api/java/lang/UnsupportedClassVersionError.html Java.lang.UnsupportedClassVersionError] means that you need a newer Java version to run the program. I'm guessing you have Java 1.4 installed. You can verify this by running a "java -version" command in the console.\r\n\r\nTo get a new version of Java, go to http://www.java.com/getjava (you need at least 5.0, the latest version is called 6.0).\r\n\r\nOn your second question - I'd recommend you read our DataQuality information page.
165	1	45	-1	1223930827	kasper	Hi Yves,\r\n\r\nWelcome to the DataCleaner forums :)\r\n\r\nYes this is possible, however it goes beyond the usual use-case (I'm not sure why you would specifically want a relative path?) which is why it has not been documented yet. But here's what you need to do:\r\n\r\n 1. You need the platform-independent version of DataCleaner (ie. one with a .cmd executable, not the .exe version)\r\n 2. You should edit the .cmd file and add the relative .jar file to the classpath - similar to this:\r\n{{{\r\ncall java -Xmx1024m -XX:MaxPermSize=256m -jar datacleaner.jar;path\\to\\my.jar\r\n}}}\r\n  * If you prefer not to see the command line console when you run the application, you can use the "javaw" command instead of "java" in that same line.\r\n\r\n 3. You should add the driver class in the '''datacleaner-config.xml''' file (look for line 28-35), like this:\r\n{{{\r\n\t<bean class="dk.eobjects.datacleaner.gui.model.DatabaseDriver">\r\n\t\t<property name="name" value="My database driver" />\r\n\t\t<property name="driverClass" value="my.database.Driver" />\r\n\t</bean>\r\n}}}\r\n\r\nI hope this makes sense?
166	1	45	-1	1223969260	kasper	Sorry, the example above is a bit wrong. Here's how it should look:\r\n\r\ncall java -Xmx1024m -XX:MaxPermSize=256m -cp path\\to\\my.jar -jar datacleaner.jar\r\n
167	1	45	166	1224081387	yves.courtois	Hello\r\n\r\nI have test your solution like [[BR]]\r\n\r\nSET DATACLEANER_CLASSPATH=%DATACLEANER_HOME%Drivers\\sqljdbc.jar\r\n\r\ncall java -Xmx1024m -XX:MaxPermSize=256m -classpath C:\\DataCleaner\\Drivers\\sqljdbc.jar -jar datacleaner.jar or  call java -Xmx1024m -XX:MaxPermSize=256m -cp C:\\DataCleaner\\Drivers\\sqljdbc.jar -jar datacleaner.jar\r\n\r\nin the 2 case this solution doesnt  work for me .\r\n\r\nlook a this picture [[BR]]\r\n\r\nhttp://fr.tinypic.com/usermedia.php?uo=xSbyXl%2BGE34qWfzHCNq93w%3D%3D\r\n\r\nhttp://i37.tinypic.com/hrar5u.jpg\r\n\r\n the relative path is not so important , but when we use java software i think it's very important to keep the fact that we could move the application and keep the original settings.\r\n\r\nThanks
168	1	45	167	1224087631	kasper	OK, i just tried it myself and saw that it's actually not working ;-) Apparently java cannot combine both the "cp" (classpath) parameter and the "jar" (executable jar) parameter, so here's how you should do it:\r\n\r\n 1. Add both jar files to the "cp"\r\n 2. Add "dk.eobjects.datacleaner.gui.DataCleanerGui" (the class inside datacleaner.jar to execute) as a suffix to the whole thing.\r\n\r\nLike this...\r\n\r\n{{{\r\ncall java -Xmx1024m -XX:MaxPermSize=256m -cp datacleaner.jar;mydriver.jar dk.eobjects.datacleaner.gui.DataCleanerGui\r\n}}}\r\n\r\nOh and you should probably also remove the driver that I can see on your screenshot that you have registered inside the application (the absolute path one). Let me know how it works out...
169	1	46	-1	1224350576	beno	I vote for the sampling/filtering functionality. A couple of my tables contains a "validated" flag where only the records that have been validated are really interesting to profile because the other ones are known to have data quality issues. So it's not so much because I want to just profile a "sample", but because only a subset of the records have real relevance.\r\n\r\nHowever, I've made an easy little workaround by just creating a view that does the filtering and then I just profile the view...
170	1	46	-1	1224707044	benbor	I will refer to each item on your list.\r\n\r\n'''sampling''' - I had to use this feature ''once'' (I was using DataFlux for profiling), when I had a very large data source (all the credit details of one of the largest Canadian banks) to profile.  So I used the sampling feature to run profiling on 10% of the data, assuming (correctly) that this will identify most of the problems with the data.  I later ran full profiling, which took a whole weekend to run.  The 10% sample took a few hours and gave me the results I needed.  I therefore vote to have sampling as a feature of DataCleaner.  It should allow you to select a percentage, then use a random or linear (this could be a user choice) algorithm to select a sample of records to profile.\r\n\r\n'''Join Testing''' - This is an essential feature of any data profiling tool.  I use it often to find, for example, all the transactions whose currency is not in the currency table.  It is possible to do this with dictionaries, but it could (and in my view even should) be made into an explicit Join Testing feature.\r\n\r\n'''Metadata Management''' - I think that currently DataCleaner is a ''data profiling'' tool, not a ''data cleaning'' tool.  I therefore see no reason to include metadata management.\r\nI would use metadata management tools when I need to ensure that my users can understand the meaning and derivation of the data that I present to them.  They need to know what I "did" to the data that they see, so that they can decide if they can trust the data.  So when I use data-cleansing tools, I would like the cleansing process to be visible to the users, therefore I would include the cleansing in the description of the data-derivation process (together with the extracting, loading and transformations that are part of the same process).\r\nI would therefore not expect DataCleaner to have any Metadata Management facilities until the tools starts actually changing the data.  When this happens, the best way would be to find some industry standard way to notify an existing Metadata tool of the work done in DataCleaner.\r\n\r\n'''Issue Management''' - again, not an important feature for me.  I'd like to see DataCleaner concentrate on the important features of profiling and cleansing.  I can't see the industry deciding on a single approach to Issue Management, therefore any solution that we may implement would be useful only to a very small percentage of the users of DataCleaner.\r\n\r\nBen
171	1	46	170	1224776486	kasper	Based on your responses I think that we should add tickets for DataCleaner 1.6 for sampling and join testing. So I will add tickets in a sec.\r\n\r\nRegarding sampling I think we will have to provide three types of sampling to support all your needs:\r\n * Simple "max rows" sampling. This will be both the easiest and probably the most performant way to make a sample.\r\n * Random selection sampling. This is not hard to implement but I fear that it will be a pretty wasteful approach performance-wise because AFAIK the only way to do this is to perform a "full" query and then do the randomizing client-side.\r\n * Based on a filter. In this scenario the user either writes an SQL WHERE-clause (for database-based datastores) or makes a MetaModel-based filter (which can transform to SQL too) based on some kind of filter-dialog.
172	3	2	159	1226662331	edwin	Hi Kasper,\r\n\r\nFor a while I couldn't find time to contribute.Now I am relatively free.I have done with the ticket #214 but couldn't check-in and later I found it has been fixed.Please let me know if you have any tickets in Datacleaner to be worked on.\r\n\r\nRegards, Edwin
173	3	2	172	1226665340	kasper	Hi Edwin,\r\n\r\nI'm sorry if you did a lot of work for nothing (since it was already fixed), but since I didn't hear from you I went ahead and fixed it myself.\r\n\r\nI think you should sign up for the [MailingLists DataCleaner mailing list] and join the discussion there on the development of DataCleaner. That way we are closer in touch. That's also a better place for the more technical discussions etc.\r\n\r\nSVN commit rights are granted after your first contributions, so for the first time you are encouraged to contribute patches instead. (see CreatingPatches for instructions).\r\n\r\nIf you're looking for a ticket to work with, I can recommend one of the features described in ticket #202 - improvements to the Pattern Finder! Should be plenty of interesting things to work with in that one :-)\r\n\r\nBest regards,\r\nKasper
174	7	48	-1	1227290812	kasper	Hi JimC,\r\n\r\nI would not like to make the private variables protected but I will make getter and setter methods for them (the remaining ones) right away! Then you can access them in your custom clone() method.\r\n\r\nThat being said, I think maybe I would try keeping the references external from the !SelectItem's themselves. What do you mean that the model goes through changes? Is it that you want to use the !SelectItem objects as keys in a !HashMap and you then change some of the properties in the flow of your application, causing the hashCode to change? That would definately cause a problem because the keys would not resolve the values once the hashcodes have changed.\r\n\r\nIn that case I would go for storing the map-information in two lists with the index as the link (would give you a performance penalty, but it would work). Or implement your own very simple Map to disguise the dual-list structure.\r\n\r\nPerhaps a third idea could be to just create a hashmap and use the select item index in the select clause as a key?
175	7	48	174	1227291169	kasper	Just updated the source code with the getters and setters. You can see it in revision [694] and we'll release it soon in MetaModel 1.1.1.
176	7	48	175	1227296915	JimC	Thanks for the super-fast update :-)\r\n\r\nI'm trying to implement a query model in java so that some simple scripting code can modify it - alter columns, add filters etc - and additionally the columns can be referred to with these category labels.\r\n\r\nI think subclassing SelectItem would be a good way to do this, but may still end up keeping an external structure to keep this.  The only trouble then is to create an API for modifying the model and keeping this structure in sync at the same time - I would have to prevent direct modfification of the underlying MetaModel object from the scripting layer.\r\n\r\nThanks again, and great work on the project.
177	7	48	176	1227303271	kasper	You're welcome, I love to hear about people who are actually using this stuff ;) I've just released 1.1.1 so you can download it from google code or the maven repository...
178	3	2	173	1227510031	edwin	Hi Kasper,\r\n\r\nI have just started looking into #202 ticket.But if you have any sample DB it would be great for me to proceed further as I am able to debug or not sure where to start?\r\n\r\nRegards, Edwin
179	3	2	178	1227514579	kasper	Hi Edwin,\r\n\r\nGreat news! :) There's a built-in sample database within the testware of DataCleaner. You can get access to it simply by extending the '''!DataCleanerTestCase''' class (for unittesting) and calling '''getTestDataContext()''' (which will give you a DataContext object.\r\n\r\nPerhaps you can have a look at the unittest for the Pattern Finder Profile, which already does this:\r\n\r\n * !PatternFinderProfileTest\r\n\r\nIf you have more technical issues like this, please ask them at the mailing list because I'm not sure that so many people are following along at the forum (it's more intended for the users)..
180	3	2	179	1227596225	edwin	Hi Kasper,\r\n\r\nI don't have access to Gmail to send and see the mails.Hence I am posting it here.\r\n\r\nYes we have a Unit test class for that, but when I ran it is just exeuting as Pass.I coouldn't find any DB inside Testware Datacleaner.Can I use MySQL (I hope we can use any type of DB)? I have created a database in MySQL and created the table called QUADRANT_ACTUALS and inserted some records.Now I wanted to connect from Datacleaner, how can I do it? \r\n\r\nRegards, Edwin
181	3	2	180	1227604220	kasper	The database in testware is an embedded HSQLDB database based on the script in [http://eobjects.org/svn/DataCleaner/trunk/DataCleaner-testware/src/main/resources/database/datacleaner.script DataCleaner-testware/src/main/resources/database/datacleaner.script] and is created in the '''!DataCleanerTestCase''' class, here's the main part (slightly simplified):\r\n{{{\r\npublic Connection getTestDbConnection() throws Exception {\r\n  Class.forName("org.hsqldb.jdbcDriver");\r\n  _connection = DriverManager.getConnection(CONNECTION_STRING, USERNAME, PASSWORD);\r\n  _connection.setReadOnly(true);\r\n  return _connection;\r\n}\r\n}}}\r\n\r\nRegarding MySQL then yes, you can easily access a MySQL database from DataCleaner but the trouble from a testing perspective is that we want to make the tests '''executable regardless of the testers environment and configuration'''. So I would strongly prefer it if you used the testware embedded database since it makes no requirements on behalf of the execution environment. Currently our Continous Integration system is offline but once it goes online again you'll see that we put a high emphasis on testability and test coverage and this is why we have had to consider how to do the database tests. Here's a skeleton for how you could design a test using the embedded database:\r\n{{{\r\npublic class EdwinsTest extends DataCleanerTestCase {\r\n  public void testSomethingWithADatabase() throws Exception {\r\n    DataContext dc = getTestDataContext();\r\n    Schema schema = dc.getDefaultSchema();\r\n    Table table = schema.getTableByName("PRODUCTS");\r\n    // Other tables include: CUSTOMERS, ORDERS etc (see the .script file for details)\r\n  }\r\n}\r\n}}}\r\nI hope this makes it more manageable to deal with for you? If you think it's really a hassle then I'm open for suggestions!
182	1	49	-1	1227725072	beno	Hi Kasper,\r\n\r\nI think these are good ideas and I personally use both the profilers and the validators (specifically the javascript validator) but it has bothered me from time to time that I had to do those two things in two seperate sessions.\r\n\r\nIn regards of a new name, here are a few suggestions:\r\n\r\nData Quality gears,\r\nAnalysis Droid (I think I'm a bit inspired by your former Chronicle Droid project here),\r\nDQ Animal or something like that, eg. "DQ dog", "DQ Penguin" or something like that :)
\.


--
-- TOC entry 1846 (class 2606 OID 16778)
-- Dependencies: 1553 1553
-- Name: message_pkey; Type: CONSTRAINT; Schema: PUBLIC; Owner: tracuser; Tablespace: 
--

ALTER TABLE ONLY message
    ADD CONSTRAINT message_pkey PRIMARY KEY (id);


-- Completed on 2008-12-24 12:05:59 CET

--
-- PostgreSQL database dump complete
--

