--
-- PostgreSQL database dump
--

-- Started on 2008-12-24 12:05:06 CET

SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = "PUBLIC", pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 1567 (class 1259 OID 16520)
-- Dependencies: 5
-- Name: topic; Type: TABLE; Schema: PUBLIC; Owner: tracuser; Tablespace: 
--

CREATE TABLE topic (
    id integer NOT NULL,
    forum integer,
    "time" integer,
    author text,
    subject text,
    body text
);


ALTER TABLE "PUBLIC".topic OWNER TO tracuser;

--
-- TOC entry 1576 (class 1259 OID 16550)
-- Dependencies: 5 1567
-- Name: topic_id_seq; Type: SEQUENCE; Schema: PUBLIC; Owner: tracuser
--

CREATE SEQUENCE topic_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE "PUBLIC".topic_id_seq OWNER TO tracuser;

--
-- TOC entry 1850 (class 0 OID 0)
-- Dependencies: 1576
-- Name: topic_id_seq; Type: SEQUENCE OWNED BY; Schema: PUBLIC; Owner: tracuser
--

ALTER SEQUENCE topic_id_seq OWNED BY topic.id;


--
-- TOC entry 1851 (class 0 OID 0)
-- Dependencies: 1576
-- Name: topic_id_seq; Type: SEQUENCE SET; Schema: PUBLIC; Owner: tracuser
--

SELECT pg_catalog.setval('topic_id_seq', 1, false);


--
-- TOC entry 1844 (class 2604 OID 16558)
-- Dependencies: 1576 1567
-- Name: id; Type: DEFAULT; Schema: PUBLIC; Owner: tracuser
--

ALTER TABLE topic ALTER COLUMN id SET DEFAULT nextval('topic_id_seq'::regclass);


--
-- TOC entry 1847 (class 0 OID 16520)
-- Dependencies: 1567
-- Data for Name: topic; Type: TABLE DATA; Schema: PUBLIC; Owner: tracuser
--

COPY topic (id, forum, "time", author, subject, body) FROM stdin;
1	1	1205490225	kasper	Welcome to the DataCleaner forum	Hi everybody.\r\n\r\nTo offer everybody the chance to enter the discussion about DataCleaner we've opened this forum. The topics in here can be everything from basic questions to the usage of DataCleaner to bugreports and feature requests! Note though, that developers of DataCleaner are expected to participate in the MailingLists which is the place for more technical subjects.\r\n\r\nHave fun with the new forum!
2	3	1205490913	kasper	Welcome to the Contributors forum	If you think eobjects.dk projects sound interesting you're hereby invited to direct any questions you have to this forum :) We have a very contributor-friendly culture in eobjects.dk so any questions will be handled politely and you can be sure to be taken seriously, even if you're a beginner or don't feel comfortable with all the technologies involved. The basis of the projects are that we should learn and have fun while doing it :)\r\n\r\nOh, and contributing can be much more than just programming ... We are looking for interested people for lots of things, among other:\r\n * Testing\r\n * Documentation\r\n * Website administration\r\n * Graphics\r\n * User-interfaces\r\n * whatever you think can be a valuable addition to eobjects.dk or it's projects.
3	1	1205493978	kasper	Confirmed working environments	Hi everybody\r\n\r\nWe need to have a "positive list" of working environments for DataCleaner (see ticket #93). I personally have tested it with the following configurations:\r\n\r\n * Databases:\r\n  * MySQL database\r\n  * Derby embedded database\r\n  * Derby client-server database\r\n * Operating systems:\r\n  * MS Windows XP\r\n  * MS Windows Vista\r\n  * Ubuntu Linux (GNOME)\r\n  * OpenSUSE Linux (KDE)\r\n\r\nI think the most crucial item here is to get tests of more databases. Everybody please tell us their experiences.
4	2	1205518952	kasper	Welcome to the BirtReportPortlet forum	This forum is for everybody interested in using, developing or discussing the BirtReportPortlet ... Enjoy!
5	4	1205520009	kasper	Welcome to the Off-topic forum	Here you ask away! Ask about programming techniques, datawarehousing, whats going on, the weather, the tv-programme, everything! ;-)
6	2	1205572252	Rob Hanson	First impressions	Just tried out this little helpful tool, found it on BIRT-exchange. Thank you very much, even though I'd like to see some improvements (specifically i'd like relative report paths instead of absolute) this tool is just what I needed and you saved me a lot of development time there ;-)
7	1	1205624517	chorn@post.com	[SOLVED] Oracle Connectivity	Is it possible to connect to a Oracle 91 db with thispackage? It is unclear whether you want to drop the jar file into the drivers dir or add the classpath somehow. Any help appreciated
8	1	1206273407	beno	Duplicate records	Hi datacleaner people... I'm wondering if you're planning to include support for finding duplicate records in a database? At my company we need a tool to find such records, this is the reasn I'm asking.
9	1	1207734666	kasper	Release 1.0 next monday	Hi everybody\r\n\r\nAs stated by the roadmap, we're releasing version 1.0 of DataCleaner next monday! Any last minute changes or bugs anyone? Please speak out...\r\n\r\n/Kasper
10	4	1207816911	kasper	Power-outtage 15-04-2008	Hi everybody.\r\nEobjects.dk will be experiencing some downtime between 8:00 and 12:00 (CET) on monday the 15th of april, 2008. This is due to some local power-installations. We hope that the operation will be swift and without any annoyance to any of you.
11	1	1208367417	HS	[SOLVED] Using Data Cleaner	Hi,\r\n\r\nSorry for the total noob question, but how can I tell if I've built data cleaner successfully (in eclipse) and how do i execute it?\r\n\r\nThx!
12	3	1208612364	kasper	I now have a blog	For developers, contributors and other interested people, I now have a blog you can check out:\r\n\r\nhttp://kaspersorensen.blogspot.com/\r\n\r\nThe blog is primarily concerned with DataCleaner and developing open source software and I hope to provide neat background stories about the ideas and principles behind the code.
13	7	1209814166	kasper	Demonstrating the mutable query	I'm bringing here a post from [http://kaspersorensen.blogspot.com my blog] that has some relevance to people interested in DataCleaner and eobjects.dk activities in general :)\r\n{{{\r\n#!html\r\n<p>Having wanted for a long time to be able to manipulate queries in an object-oriented manner is not something that I think has been just my personal ambition, but a strong barrier for a lot of data-centric applications out there. Considering the many dialects of SQL it is also striking how few attempts there has been to unify these dialects using a common meta-layer. Sure there are very succesfull (and good!) ORM frameworks like <a href="http://www.hibernate.org/">Hibernate</a> and <a href="http://java.sun.com/jdo/">JDO</a> that have built in dialect-translation but when you think about it they actually apply to a very limited scenario where you <span style="font-style: italic;">know in advance </span>how the database is structured and what objects you want to store the content of the database. Consider instead a model of a database that is not a <span style="font-style: italic;">mapping to domain objects</span>, but more an object-oriented wrapper for the database since the database <span style="font-style: italic;">is </span>the domain. The advantages of an object-oriented domain model for the database is obvious, here are a couple of pointers;</p>\r\n<ul><li>Traversing a database (schemas, tables, columns, relationships etc.) becomes as easy as it is to traverse any other domain model.</li><li>Building and manipulating queries can be a continous and type-safe process. This gives us the opportunity to do meaningful fault-tolerant query-modifications in order to recover from database-insufficiencies and to enterpret the query not only as SQL, but as a generic query built for non-SQL datastores.\r\n</li><li>It is possible now to mimic a database with other data technologies, for examples flat/csv files, excel spreadsheets, web services or hardcoded datastores.</li><li>Building systems to support the database structure (for example metadata applications) becomes possible without extensive JDBC hacking.</li></ul>\r\n<p>Anyhoot, look no further, because we have invested considerable time into these issues by developing <a href="http://www.eobjects.dk/metamodel">eobjects.dk MetaModel</a>. Let me show you how you build queries using the MetaModel framework in a totally type-safe manner!</p>\r\n<blockquote>\r\njava.sql.Connection connection = ... //Obtain a JDBC connection<br/>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/DataContext.html">DataContext</a> dataContext = new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/DataContext.html">DataContext</a>(connection);<br/>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/schema/Schema.html">Schema</a>[] schemas = dataContext.getSchemas();<br/>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/schema/Table.html">Table</a> customerTable = schemas[0].getTableByName("customers");<br/>\r\n<br/>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/Query.html">Query</a> q = new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/Query.html">Query</a>();<br/>\r\nq.addFrom(customerTable);<br/>\r\nq.addSelect(customerTable.getColumns());<br/>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/data/DataSet.html">DataSet</a> dataSet = dataContext.executeQuery(q);<br/>\r\nwhile (dataSet.next()) {<br/>\r\n&nbsp;  <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/data/Row.html">Row</a>   row = dataSet.getRow();<br/>\r\n&nbsp;  System.out.println(row.toString());<br/>\r\n}\r\n</blockquote>\r\n<p>Of course in this example a couple of hardcoded values are entered such as the "customers" literal, but I could have just as well traversed the schema by going through every table without any hard references.</p>\r\n<p>So I guess the most striking question is: Doesn't it cause some ineffeciencies to generalize queries like this? And can I still execute my custom SQL-string query? The answer is "no, because that goes against the whole idea of MetaModel". You shouldn't be able to do anything that is not portable to other datastores. Then you could just as well do it "the old" JDBC way and of course we don't prohibit you from doing so. But let's instead <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/index.html">take a look</a> at how to do regular (portable and standards-compliant) SQL queries in MetaModel:</p>\r\n<blockquote>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/Query.html">Query</a> q = new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/Query.html">Query</a>();<br/>\r\nq.addFrom(new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/FromItem.html">FromItem</a>(schema.getTable("products")).setAlias("p");<br/>\r\nq.addSelect(schema.getTable("products").getColumn("product_type"));<br/>\r\nq.addGroupBy(schema.getTable("products").getColumn("product_type"));<br/>\r\n<br/>\r\nSystem.out.println(q.toString());<br/>\r\n//yields: "SELECT p.product_type FROM products p GROUP BY p.productType"\r\n</blockquote>\r\n<p>Notice here that there are multiple overloaded addFrom() methods in Query. In the first example we added a table as the argument, in this next example we used a FromItem and gave it an alias. The same principle applies to the other parts of the query, lets see it by adding an aggregate function to our query:</p>\r\n<blockquote>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/schema/Column.html">Column</a> priceColumn = schema.getTable("products").getColumn("price");<br/>\r\nq.addSelect(new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/SelectItem.html">SelectItem</a>(<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/FunctionType.html">FunctionType</a>.SUM, priceColumn);<br/>\r\nSystem.out.println(q.toString());<br/>\r\n//yields: "SELECT p.product_type, SUM(p.price) FROM products p GROUP BY p.productType"\r\n</blockquote>\r\n<p>Okay, it seems pretty straight forward eh? That's because it <i>is</i>. So get started and use MetaModel. Here's some more examples for ya so you can see how easy it is to build even complex queries:</p>\r\n<blockquote>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/schema/Column.html">Column</a> marketYearColumn = schema.getTable("products").getColumn("market_year");<br/>\r\nSelectItem yearSelect = new SelectItem(marketYearColumn);<br/>\r\n<br/>\r\nq.addWhere(new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/FilterItem.html">FilterItem</a>(yearSelect , <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/OperatorType.html">OperatorType</a>.HIGHER_THAN, 2004));<br/>\r\nSystem.out.println(q.toString());<br/>\r\n//yields: "SELECT p.product_type, SUM(p.price) FROM products p WHERE p.market_year > 2004 GROUP BY p.productType"<br/>\r\n<br/>\r\nq.addOrderBy(new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/OrderByItem.html">OrderByItem</a>(q.getSelectClause().getItem(0),false));<br/>\r\nSystem.out.println(q.toString());<br/>\r\n//yields: "SELECT p.product_type, SUM(p.price) FROM products p WHERE p.market_year > 2004 GROUP BY p.productType ORDER BY p.product_type"\r\n</blockquote>\r\n}}}
14	1	1209939802	kasper	Release plan revisions	Thanks to the increased interest in DataCleaner we are also experiencing that the plans for the next releases are exploding and various refactorings are being worked on to scale up the project to comprehend all these visionary improvements. Because of this we have moved the [/trac/roadmap milestone dates] a bit; here's a wrap-up:\r\n\r\n * Next release is version 1.1, planned for the 20th of june. The release major theme of the release is enhancements to the core and GUI allowing users to compare databases and use different kinds of dictionary lookups to classify the content of data. Among other notable features are new profiles and validation rules to identify natural keys, duplicate records along with an improved user interface where users can drill/explode the measures of profile results to view which records yields which measures.\r\n * Version 2.0 of DataCleaner is planned for the 15th of september. The major theme and reason for the incremented major version number of this release is the development of the webmonitor. The webmonitor will leverage DataCleaner from a desktop-application to an enterprise application for automated, scheduled and continous data quality.
15	1	1210329745	MFontana	[SOLVED] Profiling Fails	First of all thanks for this impressive sw! I'm really interested in using DataCleaner to profile a large amount of databases but I'm experiencing some troubles. When trying to query large tables (about 1 million rows) the profiling fails returning a jdbc error. Is this error related to the big number of rows or there's some parameter to be tuned in jdbc as it happens in odbc? 
16	1	1211048039	kasper	Demonstrating the mutable query	I'm bringing here a post from [http://kaspersorensen.blogspot.com my blog] that has some relevance to people interested in DataCleaner and eobjects.dk activities in general :)\r\n{{{\r\n#!html\r\n<p>Having wanted for a long time to be able to manipulate queries in an object-oriented manner is not something that I think has been just my personal ambition, but a strong barrier for a lot of data-centric applications out there. Considering the many dialects of SQL it is also striking how few attempts there has been to unify these dialects using a common meta-layer. Sure there are very succesfull (and good!) ORM frameworks like <a href="http://www.hibernate.org/">Hibernate</a> and <a href="http://java.sun.com/jdo/">JDO</a> that have built in dialect-translation but when you think about it they actually apply to a very limited scenario where you <span style="font-style: italic;">know in advance </span>how the database is structured and what objects you want to store the content of the database. Consider instead a model of a database that is not a <span style="font-style: italic;">mapping to domain objects</span>, but more an object-oriented wrapper for the database since the database <span style="font-style: italic;">is </span>the domain. The advantages of an object-oriented domain model for the database is obvious, here are a couple of pointers;</p>\r\n<ul><li>Traversing a database (schemas, tables, columns, relationships etc.) becomes as easy as it is to traverse any other domain model.</li><li>Building and manipulating queries can be a continous and type-safe process. This gives us the opportunity to do meaningful fault-tolerant query-modifications in order to recover from database-insufficiencies and to enterpret the query not only as SQL, but as a generic query built for non-SQL datastores.\r\n</li><li>It is possible now to mimic a database with other data technologies, for examples flat/csv files, excel spreadsheets, web services or hardcoded datastores.</li><li>Building systems to support the database structure (for example metadata applications) becomes possible without extensive JDBC hacking.</li></ul>\r\n<p>Anyhoot, look no further, because we have invested considerable time into these issues by developing <a href="http://www.eobjects.dk/metamodel">eobjects.dk MetaModel</a>. Let me show you how you build queries using the MetaModel framework in a totally type-safe manner!</p>\r\n<blockquote>\r\njava.sql.Connection connection = ... //Obtain a JDBC connection<br/>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/DataContext.html">DataContext</a> dataContext = new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/DataContext.html">DataContext</a>(connection);<br/>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/schema/Schema.html">Schema</a>[] schemas = dataContext.getSchemas();<br/>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/schema/Table.html">Table</a> customerTable = schemas[0].getTableByName("customers");<br/>\r\n<br/>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/Query.html">Query</a> q = new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/Query.html">Query</a>();<br/>\r\nq.addFrom(customerTable);<br/>\r\nq.addSelect(customerTable.getColumns());<br/>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/data/DataSet.html">DataSet</a> dataSet = dataContext.executeQuery(q);<br/>\r\nwhile (dataSet.next()) {<br/>\r\n&nbsp;  <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/data/Row.html">Row</a>   row = dataSet.getRow();<br/>\r\n&nbsp;  System.out.println(row.toString());<br/>\r\n}\r\n</blockquote>\r\n<p>Of course in this example a couple of hardcoded values are entered such as the "customers" literal, but I could have just as well traversed the schema by going through every table without any hard references.</p>\r\n<p>So I guess the most striking question is: Doesn't it cause some ineffeciencies to generalize queries like this? And can I still execute my custom SQL-string query? The answer is "no, because that goes against the whole idea of MetaModel". You shouldn't be able to do anything that is not portable to other datastores. Then you could just as well do it "the old" JDBC way and of course we don't prohibit you from doing so. But let's instead <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/index.html">take a look</a> at how to do regular (portable and standards-compliant) SQL queries in MetaModel:</p>\r\n<blockquote>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/Query.html">Query</a> q = new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/Query.html">Query</a>();<br/>\r\nq.addFrom(new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/FromItem.html">FromItem</a>(schema.getTable("products")).setAlias("p");<br/>\r\nq.addSelect(schema.getTable("products").getColumn("product_type"));<br/>\r\nq.addGroupBy(schema.getTable("products").getColumn("product_type"));<br/>\r\n<br/>\r\nSystem.out.println(q.toString());<br/>\r\n//yields: "SELECT p.product_type FROM products p GROUP BY p.productType"\r\n</blockquote>\r\n<p>Notice here that there are multiple overloaded addFrom() methods in Query. In the first example we added a table as the argument, in this next example we used a FromItem and gave it an alias. The same principle applies to the other parts of the query, lets see it by adding an aggregate function to our query:</p>\r\n<blockquote>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/schema/Column.html">Column</a> priceColumn = schema.getTable("products").getColumn("price");<br/>\r\nq.addSelect(new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/SelectItem.html">SelectItem</a>(<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/FunctionType.html">FunctionType</a>.SUM, priceColumn);<br/>\r\nSystem.out.println(q.toString());<br/>\r\n//yields: "SELECT p.product_type, SUM(p.price) FROM products p GROUP BY p.productType"\r\n</blockquote>\r\n<p>Okay, it seems pretty straight forward eh? That's because it <i>is</i>. So get started and use MetaModel. Here's some more examples for ya so you can see how easy it is to build even complex queries:</p>\r\n<blockquote>\r\n<a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/schema/Column.html">Column</a> marketYearColumn = schema.getTable("products").getColumn("market_year");<br/>\r\nSelectItem yearSelect = new SelectItem(marketYearColumn);<br/>\r\n<br/>\r\nq.addWhere(new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/FilterItem.html">FilterItem</a>(yearSelect , <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/OperatorType.html">OperatorType</a>.HIGHER_THAN, 2004));<br/>\r\nSystem.out.println(q.toString());<br/>\r\n//yields: "SELECT p.product_type, SUM(p.price) FROM products p WHERE p.market_year > 2004 GROUP BY p.productType"<br/>\r\n<br/>\r\nq.addOrderBy(new <a href="http://www.eobjects.dk/hudson/job/MetaModel/ws/trunk/target/site/apidocs/dk/eobjects/metamodel/query/OrderByItem.html">OrderByItem</a>(q.getSelectClause().getItem(0),false));<br/>\r\nSystem.out.println(q.toString());<br/>\r\n//yields: "SELECT p.product_type, SUM(p.price) FROM products p WHERE p.market_year > 2004 GROUP BY p.productType ORDER BY p.product_type"\r\n</blockquote>\r\n}}}
17	1	1211361474	MFontana	[SOLVED] Reporting	Maybe I missed something, but I found quite difficult to export results of DataCleaner analysis to other formats. I managed to do so only by copy&paste. There is a structured way to print report or export results? \r\nThank you in advance
18	7	1211479437	kasper	!MetaModel has been roadmapped	Today I have reorganized the [/trac/roadmap roadmap] with a new milestone - MetaModel 1.0.\r\n\r\nWe plan on releasing MetaModel 1.0 pretty soon. We are thoroughly testing MetaModel to find any glitches but I believe we are ready for a release very soon and there aren't a lot of pending tickets either. With the release we will distribute MetaModel to the central maven repository which will help broaden the knowledge of the wonderful component :)
19	1	1211479974	kasper	datacleaner core now available in the central maven rep.	There you go... Finally I managed to do the maven repository registration right ;-)\r\n\r\nAnyone who want's to draw on the wonders of DataCleaner core can just add this dependency to their POM's:\r\n\r\n{{{\r\n<dependency>\r\n <groupId>dk.eobjects.datacleaner</groupId>\r\n <artifactId>DataCleaner-core</artifactId>\r\n <version>1.0</version>\r\n</dependency>\r\n}}}
20	1	1213374713	anonymous	[SOLVED] support for Oracle schemas	Hi. Just starting to play around with this tool and have a question about how to get access to different schemas than the one used for connection to an Oracle database. There seems to be no option to specify that on connection dialog ("catalog" doesn't do anything) and I only see objects that belong to the user I'm logging in as. Thanks.
21	1	1213516245	kasper	Report on DataCleaner development process	Just a short snippet from [http://kasper.eobjects.dk my blog], where I've announced the results of the academic project associated with DataCleaner...\r\n\r\nAs some of you may know DataCleaner started as an academic project for me, investigating how Open Source projects are established, managed and developed. I've been waiting for a long time for the evaluation of the project but yesterday I finally got the results, and I'm proud to announce that I got the top-grade for the assignment! (12 in the danish grading system, which spans from -2 to 12 - I'll have to blog about the grading system some time, it's hilarious).\r\n\r\nThe project received notable credits for the explorative style of development and this is something that I'm very proud to keep on practicing. I'm publishing the report for free download here, but I'm affraid it's in Danish, so if you don't understand it you'll have to ... learn Danish ;-)\r\n\r\n    * Download '[/resources/download/afloesningsopgave.pdf Udvikling og styring af Open Source projekter]' here (in Danish)\r\n\r\nI would appreciate any kind of feedback on my research and I don't mind critics now that I have the acknowledgment of Copenhagen Business School, heh.
22	1	1214311679	kasper	DataCleaner 1.2 is out!	Finally one might say! :) We're proud to release DataCleaner 1.2 which is a major feature and UI enhancement release. Some of the cool new features of DataCleaner includes: \r\n \r\n * You can now drill to details in profiling results, so if you want to know which rows yield which profile results it is now possible to explore the results! \r\n * There are now catalogs of regexes and dictionaries that can be reused in various settings; categorization of values based on dictionaries, validation based on regexes etc. \r\n * Better compatibility for various datastores including CSV, Excel, OpenOffice databases, JDBC databases (MySQL, Postgresql, Oracle, HSQLDB, FirebirdSQL and more...) \r\n * Comparison of datastores to get an overview of synchronized datastores. \r\n \r\nWith the 1.2 release of DataCleaner we can with confidence say that we have provided the most advanced Open Source Data Quality solution ever seen! Be sure to [GetDataCleaner get DataCleaner 1.2] right away!
23	1	1214427021	kgeis@berkeley.edu	[SOLVED] problems with SQL Server dbo schema	Hi.  I am really excited about DataCleaner.  I could use it as a generic replacement for a tool that I wrote just to profile/validate one column in a database.\r\n\r\nI just downloaded 1.2, but I can't get it working on my database.  I'm trying SQL Server 2005, using both Microsoft's driver and the JTDS driver.  With either, when I go to preview the table or profile the data, I get an error like this:\r\n\r\n        INFO  JdbcDataContextStrategy - SELECT "action_status"."ai_key", "action_status"."action_status", "action_status"."created", "action_status"."obsolete" FROM dbo."action_status"\r\n\r\n        WARN  JdbcDataContextStrategy - Exception occurred when executing query: Invalid object name 'dbo.action_status'.\r\n\r\n        Exception in thread "AWT-EventQueue-0" dk.eobjects.metamodel.MetaModelException: Could not execute query\r\n\r\n                at dk.eobjects.metamodel.JdbcDataContextStrategy.executeQuery(JdbcDataContextStrategy.java:385)\r\n\r\n                at dk.eobjects.metamodel.DataContext.executeQuery(DataContext.java:280)\r\n\r\n                at dk.eobjects.datacleaner.gui.windows.PreviewDataWindow.<init>(PreviewDataWindow.java:45)\r\n\r\n\r\nIf I copy-and-paste the query into Oracle SQL Developer (connecting to SQL Server using the JTDS driver) it works fine.\r\n\r\nShould I just file this as a bug?
24	2	1215681115	jasonfly	[SOLVED] doesn't work for me	Hi everyone,\r\nI don't know if I haven't got the right version but it doesn't work that well for me.\r\n\r\n1. I don't have the icons\r\n2. I can't browse the folders\r\n\r\nI would be more than glad to help. I think doing this portlet is a great idea. I just need some help to identify the problems\r\n\r\nDavid Roon
25	1	1215682363	ItOnlyRains	[SOLVED] Profiler improvements	I came across these two almost right away when started using profiler and I'm sure they would add alot of value to the software:\r\n\r\n - Preview: if table contains lots of columns then preview window (in both tree and data selection) becomes very wide with no scrollers and is impossible to navigate through. Also the number of records for preview in data selection doesn't do anything as it always shows 20 (may be becase vertical scroller is missing as well).\r\n - Profiler result window: again for tables with large number of columns (heh all my tables are very wide) it becomes not that convenient to navigate through results. Although scrollers are there - it would be much better to swap columns with rows in it: rows become column names and columns become actual measures. In my opinion it becomes much more clearer that way.\r\n
26	7	1216296719	kasper	New webcast demonstration	Hey everybody,\r\n\r\nIf you want an easy introduction to using MetaModel you can check out the new [MetaModelProgrammingWebcast webcast demonstration] called "Programming with !MetaModel". It examplifies some basic project configuration and using the framework to query different kinds of datastores.\r\nEnjoy
27	7	1216363232	anonymous	DBF support	dBase and FoxPro file format dbf support should be very interesting.
28	7	1216386381	ybtan	[SOLVED] Is there any plan to support XML format data?	I think many applications store their data in XML format.\r\nIs there any plan to support this function?
29	7	1216476455	rajesh_b_2k	Support for LDAP and other datastores	I started reading about this project and it really sounds interesting.\r\n\r\nI was wondering if it is possible to support other datastores like \r\n\r\n1. LDAP\r\n2. Files (Already this is supported)\r\n3. SAP adaptors to pull data from.\r\n\r\nIt would be great if atleast LDAP is supported with databases that you already support.\r\n\r\nAny thoughts on this would be of great help.\r\n\r\n~Rajesh.B
30	7	1216569866	antiso	How to use functions on left operand in where clause?	Hello,\r\n\r\nHow to build query like this using MetaModel:\r\n{{{\r\n#!sql\r\n\r\nSELECT * FROM computer c\r\nWHERE c.ip1 & 12 = 0;\r\n}}}\r\n\r\n!FilterItem requires that provided !SelectItem have to be a column type. So more precisely, how to represent "c.ip1 & 12" as a !SelectItem having type "column"?\r\n\r\nRegards,\r\nVladimir
31	7	1216646372	anonymous	Can !MetaModel create the database columns and tables it represents?	Could you use MetaModel to create a table or column through java code without any SQL?  Is there any examples of this?  Thanks.
32	7	1216729942	antiso	[SOLVED] Alaiases quotation	Hello, \r\n\r\nThere is some issue with aliases for !SelectItem's . If alias contains some special characters like minus "-" an alias for select item should be quoted to be accepted by DB. Example: SELECT a AS `test-alias`. Now this alias doesn't work in form "test-alias" and work in form "`test-alias`". It could be fixed for some cases if aliases will be quoted with _column.getQuote() symbol. But there is a case when !SelectItem isn't bound to column and thus quote symbol should be got elsewhere. But I haven't found a place where !SelectItem can get this symbol. Could you suggest any solution for this?\r\n\r\nP.S Unfortunately back quote char isn't shown by this Wiki engine. See source for this message to see original post.
33	7	1216735741	antiso	[SOLVED] Case sensitivity for tables and columns.	Is there any special conditions that require getting tables and columns in a case sensitive way for getTableByName() and getColumnbyName() methods? Seems like it will be better to do it in cases insensitive way for a while and introduce parameter controlling this behavior later.
34	7	1217084508	antiso	How to use IN operator?	Seems like there is no ability to use IN operator in !SQL queries. Probabaly I missed something?
35	1	1217337455	kasper	Validating Danish names	Hi everybody,\r\n\r\nAttached to ticket #25 you can find some text files that can be used to validate danish names using the Dictionary Lookup validation rule. I'm posting this because I know that there are a couple of danish users out there, so please enjoy!\r\n\r\nOn another note - if anyone has similar validation data available, please go ahead and post it and we will make sure it gets into the DataCleaner resources project which will contain regexes, dictionaries and other input-data to make efficient use of the data quality framework.
36	7	1217435057	scorreia	Feedback on some queries	Hi,\r\n\r\nI have some sample queries and I would like to know whether your parser is able to parse them correctly. If yes, I will try it by myself. If not, I'll come back later maybe ;-)\r\n\r\nHere are some of the queries I need to parse:\r\n\r\nSELECT  EXTRACT(YEAR FROM TEST_DATE) AS Y , COUNT(*) c FROM TEST_TABLES.TEST_COUNT r GROUP BY Y ORDER BY c DESC \r\n\r\nSELECT * FROM (SELECT TO_NUMBER(TO_CHAR(POST_DATE, 'YYYY')) , TO_NUMBER(TO_CHAR(POST_DATE,'Q')) , TO_NUMBER(TO_CHAR(POST_DATE,'MM')) , TO_NUMBER(TO_CHAR(POST_DATE, 'IW')), COUNT(*) c FROM ROOT.DATES r GROUP BY TO_NUMBER(TO_CHAR(POST_DATE, 'YYYY')) , TO_NUMBER(TO_CHAR(POST_DATE,'Q')) , TO_NUMBER(TO_CHAR(POST_DATE,'MM')) , TO_NUMBER(TO_CHAR(POST_DATE, 'IW')) ORDER BY c DESC)  subquery WHERE ROWNUM <= 20\r\n\r\n\r\nSELECT "TEST_DOUBLE", COUNT(*) OVER( ) total, CAST(COUNT(*) OVER( ) AS DECIMAL)/2 mid, CEIL(CAST(COUNT(*) OVER( ) AS DECIMAL)/2) next, ROW_NUMBER() OVER ( ORDER BY "TEST_DOUBLE") rn FROM "ROOT"."TEST_COUNT" \r\n\r\nSELECT AVG("TEST_DOUBLE") FROM ( \r\n                   SELECT "TEST_DOUBLE", COUNT(*) OVER( ) total, CAST(COUNT(*) OVER( ) AS DECIMAL)/2 mid, CEIL(CAST(COUNT(*) OVER( ) AS DECIMAL)/2) next, ROW_NUMBER() OVER ( ORDER BY "TEST_DOUBLE") rn FROM "ROOT"."TEST_COUNT" \r\n                    ) x WHERE ( MOD(total,2) = 0     AND rn IN ( mid, mid+1 ) ) OR ( MOD(total,2) = 1 AND rn = next )\r\n\r\n\r\nThanks for your help.\r\n\r\nRegards,
37	4	1217521087	Manjunath_Naganna	Advantages of using !MetaModel than other O/R mapping tool	Hi,\r\n\r\n   I am Manjunath R N, I was just going through MetaModel project i found it\r\n   interesting but the i have certain doubts like even MetaModel has mapping \r\n   xml as hibernate, Object oriented way querying even hibernate has this \r\n   feature using criteria queries.\r\n\r\n   I need to know what are the major differences between MetaModel and O/R   \r\n   Mapping tool (Ex : Hibernate).\r\n\r\n   In what way MetaModel is different from Hibernate. I need to know the \r\n   features that makes MetaModel better than Hibernate.\r\n\r\n- Manjunath
38	7	1217540323	Porter	[SOLVED] Consider inner enumeration	Just a thought - but as I was working through the example and leveraging the Query.orderBy() method I noticed that the method uses a boolean to control whether or not to return the results in ascending or descending order.\r\n\r\nLike so:\r\n\r\nq.orderBy(tables[0].getColumns()[2], false);\r\n\r\nConsider an public inner enumeration on Query for flags like that.  It'd help hide the details and capture the meaning a little better.  Either that or consider a public enumeration named "OrderBy" in the Query package.  That way the method might look like:\r\n\r\nq.orderBy(tables[0].getColumns()[2], OrderBy.DESC);\r\n\r\nThe advantage is that when you read this code it's clear exactly what will happen.  With the original, when you come back to the code you wrote a month ago, you might puzzle for a few moments over what exactly the true/false does.\r\n
39	7	1217936764	kasper	!MetaModel 1.0.4 released	Hi everybody,\r\n\r\nThanks to all the great feedback we've recieved the last couple of weeks we're already putting out a new version of MetaModel with a lot of minor improvements, bugfixes and API neatness. Here's a short list of improvements (from 1.0):\r\n\r\n * Improvement #176: Added support for reading arbitrary XML files into the schema model.\r\n * Compliancy #155: Added SQLite support.\r\n * Defect #188: CSV/Excel/XML queries with only aggregate functions failed to calculate properly.\r\n * API neatness #179: Case-insensitive getTableByName and getColumnByName methods\r\n * API neatness #185: Enumeration for picking direction in ORDER BY clause\r\n * Performance improvement #187: Better handling of preview (max rows property) queries for CSV/Excel/XML files.
40	7	1218541142	Radgon	[SOLVED] How does Excel SQL work?	Hi,\r\n\r\nI tried the following with an Excel structure below:\r\n\r\nDataContext dataContext = new DataContext(new File("Mappe1.xls"));\r\n\r\nSchema schemas = dataContext.getDefaultSchema();\r\nTable[] customerTable = schemas.getTables();\r\n\r\nQuery q = new Query();\r\nColumn[] cols = new Column[1];\r\ncols[0] = new Column("data1");\r\nq.select(cols);\r\nq.from(customerTable[0]);\r\nSystem.out.println(q.toString());\r\n\r\nDataSet dataSet = dataContext.executeQuery(q);\r\nwhile (dataSet.next()) {\r\n  Row row = dataSet.getRow();\r\n  System.out.println(row);\r\n}\r\n\r\nExcel structure:\r\n\r\ntestfall\tdata1\tdata2\tdata3\r\nneu\t1111\tneu\tneu\r\ntest    test    test    test\r\n\r\nThanks and Regards\r\n\r\nAlex
41	4	1220346868	beno	eobjects.org not available	Greetings eobjects.dk/.org\r\n\r\nCongratulations on your new eobjects.org domain registration. I see that you have changed a lot of the URLs on these pages but I cannot go to www.eobjects.org, only the .dk domain works?
42	3	1221501968	Coffee Logos	Free Animated Data Cleaner Logo	Hello, My name is Rob. I own "Coffee Logos" a Free Logo Company dedicated to offer Free Open-Source Programs animated looped logos.\r\n\r\nHere is the Free Animated Logo I've offer to you. By choosing this logo you agree to credit Coffee Logos for what is given. You may not change, alter what will be provided when we finalize the logo. Although if you wish to change anything after we finalize the logo you may contact me to do so.\r\n\r\n\r\n( Requires Flash Player 8+ to view )\r\nhttp://www.imagecabin.com/view_album.php?albid=11800 and click on your Program's name to view it. If logo fails to show you may have to wait a moment before it will play.\r\n\r\n\r\n( Made in Flash Pro 8 ) If you choose to use this free logo it shall be sent in any format you wish and any resolution you want. And of course the watermark will be removed if you choose to use our logo.\r\n\r\nIf you wish to change any part of this logo contact me in this thread as i will check back here for a week everyday. If you wish to contact me after the week you may e-mail me at( robert_chubb(AT)live(DOT)com ) \r\n
43	1	1222148427	beno	Some useful dictionaries	Hi everybody,\r\n\r\nI've been trying out your product and lurking on these forums for a couple of weeks and I really like what I'm seeing. I've been using DataCleaner to profile a dataset consisting mainly of people-data, such as names, nationality etc.\r\n\r\nFor this I started using the provided name dictionaries but quickly I understood that these are only for Danish people?! Anyways, I've collected four new dictionaries that I think could perhaps be of some use by everyone, so I want to know if you want them for your application?\r\n\r\nThe dictionaries are: List of nationalities, List of countries, US top 1000 male names, US top 1000 girl names
44	1	1222325244	vipinmishra82	unable to open datacleaner	Enter your message here...\r\n\r\nHI,\r\ni have  configured 1.4 Data Cleaner of  every step as in insatllation guide had given but it is not showing me the data Cleaner GUI .IT giving me exception Exception in Thread Main:\r\nJava.lang.Unsupported class version Error \r\n\r\nso reply me also how it differ from ETL
45	1	1223925750	yves.courtois	JDBC Relative Path	Hello\r\n\r\nI am a new user of Datacleaner. i have just setup a connection with MSSQL Server and i would know if is possible to register à JDBC driver whith a relative path in a Windows environnement.\r\n\r\nThanks[[BR]]\r\n\r\nBest regards Yves
46	1	1224330681	kasper	Data quality best practices	Yesterday I was taking a look at some white papers from some of the proprietary data quality solutions, namely these two papers on best practices:\r\n\r\n * [http://www.businessdataquality.com/site_files/BDQ%20Data%20Profiling%20Paper%20v1.5.pdf Data Profiling: Underpinning Data Management]\r\n * [http://www.businessdataquality.com/site_files/BDQ%20Data%20Profiling%20Paper%20v1.2.pdf Data quality best practices]\r\n\r\nI was thinking that I wanted to have a look at their recommended approach to data quality to evaluate whether or not DataCleaner could do the job in their best practice fashion. Here are a couple of features that I stumbled upon and want to ask everyone about:\r\n\r\n'''sampling''' - the principle of taking out a "piece of the cake" to run profiling on just that piece as a seperate analysis. Do you guys need such a feature? It would be rather easy to build into DataCleaner I think, but it just never occurred to me as interesting to filter the data that you're profiling. But I guess it could be useful?\r\n\r\n'''join testing''' - while this is something that is possible in DataCleaner by using dictionaries, it's not something that we have approached directly as a distinct feature. And by incorporating joins within the same data source we could also do it quite a lot faster than using the dictionary approach. So what do you guys think? Is this a feature that is important?\r\n\r\n'''metadata management''' - I would personally hate to implement our own metadata management system as that would just be another information silo with no connection to the outside world. So here's a question to everybody - are there any good Open Source metadata management components or applications out there that have good compatibility etc.?\r\n\r\n'''issue management''' - There's a mentioning of issue management tools to handle the lifecycle of data quality issues. This is a very interesting feature I think but I've never seen it in practice. Which systems do data warehouse developers use to track issues? And should we provide integration with some of these systems? (For example, a right click option in the profiling results called "mark measure as issue in [issue tracker]").\r\n\r\nThese are some loose ideas for the vision of DataCleaner and I can't promise that we will do them all but they definately caught MY interest... So let's hear it if you think it's something we should put into the [/roadmap roadmap]! All in all I must say that comparing DataCleaner to proprietary data quality solutions is quite a pleasure... We're doing quite alright! ;-)
47	7	1226424179	kasper	New !MetaModel example on my blog	Hi guys,\r\n\r\nI've updated my blog with an example of using the MetaModel API on my blog:\r\n\r\nhttp://kasper.eobjects.dk/2008/11/querying-csv-file.html\r\n\r\nIt contains (among other things) some elaborate queries and some examples of the new column type detection, narrowing and value transformation features.
48	7	1227287322	JimC	[SOLVED] A way to sublass !SelectItems?	Hi Kasper,\r\n\r\nI'm wondering if there is a way I could sublass !SelectItems?\r\n\r\nMy case is that I wish to hold additional information with a query model - this is a list of String categories, where each column from the query can be assigned to one or more categories.\r\n\r\nI tried doing this by sublassing !SelectItem, but couldn't find a way to implement the Clone() method in particular without access to the internals of the parent class.  Maybe (some of) these could be made protected instead?\r\n\r\nI can't think of a good alternative - I could try storing an external map tracking which items are in which categories, but this is difficult to keep syncronised as the model goes through changes.\r\n\r\nThanks,\r\nJimC
49	1	1227606132	kasper	New name and new concepts in !DataCleaner(?)	Hi everybody,\r\n\r\nLately I have been occupied with two high-level issues that I think persist for DataCleaner:\r\n\r\n 1. The name is misleading (and slightly "boring" IMO) since we don't provide any real data cleansing capabilities. I think we should come up with a new name that is more fitting... Or perhaps just a genuine name that is neutral of what it is we do (similar to Clover, Kettle, Gimp, Linux, Gnome and Geronimo, which are names of OSS products that are named without direct reference to their product type).\r\n 2. I want to re-invent the user interface of DataCleaner GUI and thereby remove the sharp separation that we have made between the Profiler and Validator part of the application. I think that from the users perspective it's a weird separation and in the technical design of DataCleaner it's also beginning to be a poor design decision (I have been secretly working on a redesign of some of these things but I'll wait a bit before going public with them). I think we should settle on the common term "data analysis" which would put "profiling" as a category and "validation" as another category of analysis. Other types of analysis will also be possible, for example the infamous relationship profiling which is a more explorative type of profile.\r\n\r\nIn response to these issues I'd like to ask you all:\r\n\r\n 1. Do you agree on the point of view that I'm laying out here?\r\n 2. Do you have any ideas for a new name of the application?\r\n\r\nBest regards,\r\nKasper
\.


--
-- TOC entry 1846 (class 2606 OID 16806)
-- Dependencies: 1567 1567
-- Name: topic_pkey; Type: CONSTRAINT; Schema: PUBLIC; Owner: tracuser; Tablespace: 
--

ALTER TABLE ONLY topic
    ADD CONSTRAINT topic_pkey PRIMARY KEY (id);


-- Completed on 2008-12-24 12:05:06 CET

--
-- PostgreSQL database dump complete
--

